#====================
#    TASKs
#====================
	.global min
	.global secret_task
	.global flag_xorst_2nd 			#b
	.global flag_debug  			#b

min:
	jsr 	clear_vram
min_time_get:
	mov 	time_data,a0
	jsr 	gettime
	mov 	time_data,a0
	mov 	day_seed,a2
	jsr 	getdayseed
	mov 	day_seed,a0
	mov 	day_data,a1
	jsr 	getday

	mov 	time_data,a0
	mov 	time_ampm,a1
	mov 	time_data,a2 			#㏑
	mov 	(mode_ampm),d3 			#d30(24H)͉̎AĂB
	jsr 	getampm

min_draw_obj:
	mov 	vram+4,a0
	mov 	object_list,a1
	jsr 	mr_obj
	mov 	d0,(debug_va3)

min_draw_etc:
	mov 	vram+4,a0
	mov 	logo_mmp,a1
	mov 	logo_point,a2
	jsr 	draw_mmp 					#LOGO
	mov 	vram+4,a0
	mov 	logo_square_point,a1
	jsr 	draw_square

	mov 	vram+4,a0
	mov 	line_point,a1
	jsr 	draw_linec

	mov 	(flag_debug),d0 			#DEBUG?
	cmp 	1,d0
	beq 	min_draw_debug

	mov 	vram+4+62+102*3,a0
	mov 	time_data,a2
	mov 	1,d3
	jsr 	ymd2vram40x8_no_year

	mov 	vram+4+86+102*3,a0
	mov 	day_data,a2
	jsr 	day2vram12x8

	mov 	vram+4+62+102*4,a0
	mov 	time_data,a2
	jsr 	hm2vram40x16

	mov 	vram+4+62+102*6,a0
	mov 	time_ampm,a2
	mov 	(mode_ampm),d3
	jsr 	ampm2vram8x8

	mov 	vram+4+86+102*6,a0
	mov 	time_data,a2
	jsr 	sec2vram16x8 				#D CLOCK

	mov 	(flag_lock),d0
	cmp 	0,d0
	beq 	min_end
	
	mov 	vram+4,a0
	mov 	logo_reverse_point,a1
	jsr 	draw_reverse
	
	jmp 	min_end

min_draw_debug:
	mov 	vram+4+62+102*2,a0
	mov 	time_data,a2
	mov 	1,d3
	jsr 	ymd2vram40x8_no_year

	mov 	vram+4+86+102*2,a0
	mov 	day_data,a2
	jsr 	day2vram12x8

	mov 	vram+4+62+102*3,a0
	mov 	time_data,a2
	jsr 	hm2vram40x16

	mov 	vram+4+62+102*5,a0
	mov 	time_ampm,a2
	mov 	(mode_ampm),d3
	jsr 	ampm2vram8x8

	mov 	vram+4+86+102*5,a0
	mov 	time_data,a2
	jsr 	sec2vram16x8 				#D CLOCK

	mov 	(flag_lock),d0
	cmp 	0,d0
	beq 	min_draw_etc2
	
	mov 	vram+4,a0
	mov 	logo_reverse_point,a1
	jsr 	draw_reverse

min_draw_etc2:
##########DEBUG#############
	mov 	vram+4+102*6+66,a0
	mov 	(debug_va1),d1
	jsr 	disp_v16

	mov 	vram+4+102*6+86,a0
	mov 	(debug_va2),d1
	jsr 	disp_v16

	mov 	vram+4+102*7+66,a0
	mov 	obj_rumia,a1
	mov 	(VALUE_RANDAM_DELAY,a1),d1
	jsr 	disp_v16

	mov 	vram+4+102*7+86,a0
	mov 	obj_rumia,a1
	mov 	(VALUE_MMP_STATUS,a1),d1
	jsr 	disp_v16
############################

min_end:
	jsr 	lcd_display
	rts

	.include	"main_obj.s"


#================
#^XNf[^
#================
	.include	"main_mmp_data.s"
.align 2

logo_point: 		.short 63,2
logo_square_point: 	.short 60,0,101,15

line_point: 		.short 60,0,60,64

mode_ampm: 				.short 0
logo_reverse_point: .short 61,1,100,14

debug_va1: 				.short 0
debug_va2: 				.short 0
debug_va3: 				.short 0
debug_va4: 				.short 0

flag_debug: 			.short 0

#reverse_point: 		.short 0,0,30,2
#square_point: 		.short 0,0,23,1
#square_point2: 		.short 33,0,60,1
#person_point: 		.short 27,40,29,44
#mmp_convert_point: 	.short 0,0,60,8
#mmp_point2: 		.short 0,1


.align 2
logo_mmp: 		.byte	0x25,0x00,0x0C,0x00
				.byte	0x40,0xFE,0xFE,0x42,0x02,0xFE,0xFC,0x02
				.byte	0x02,0xFE,0xFE,0x02,0x02,0x00,0xFC,0xFC
				.byte	0x40,0xFC,0xFC,0x00,0xFC,0xFC,0x24,0xFC
				.byte	0xFC,0x00,0xFC,0xFC,0x80,0x80,0x80,0x00
				.byte	0xFC,0xFC,0x30,0xE8,0xC4,0x00,0x07,0x07
				.byte	0x04,0x04,0x07,0x03,0x00,0x00,0x07,0x07
				.byte	0x00,0x00,0x00,0x02,0x02,0x02,0x02,0x02
				.byte	0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02
				.byte	0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02
				.byte	0x02,0x02

.align 2
#.lcomm square_point_list , 8*32
#.lcomm square_point2_list ,8*32
#.lcomm converted_mmp_buffer , 102*8+4

#=====================
#	SECRET TASK
#=====================
#EGG
secret_task:
#	jsr 	user_interface
	mov 	vram+4+38+102*4,a0
	mov 	secret_data,a1
	jsr 	str2vram
	
	jsr 	lcd_display
	rts

secret_data:
	.asciz "GIKO"

#=========================
#     DISP VALUE16
#=========================
#d1Ɋi[ꂽ16bit(ő0xFFFF)̒l16iŕ\B
#fobOp̃vO
# moji2vram4x8 KvƂ̂ŒӁB
#íj
#a0:o͂VRAMʒu
#d1:o͂l(16bit)
disp_v16:
	add 	-2,a3
	mov 	d1,(0,a3)
disp_v16_bit0_3: 				#4bit
	add 	20,a0 				#o͂邽
	mov 	0x000f,d0
	and 	d0,d1
	extxu 	d1
	jsr 	disp_v16_hexlize
disp_v16_bit4_15_prepare:
	mov 	3,d2
disp_v16_bit4_15: 				#5bitځ`15bitڂ܂ŁB[vŌyʉ
	mov 	(0,a3),d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	extxu 	d1
	mov 	d1,(0,a3)
	mov 	0x000f,d0
	and 	d0,d1
	jsr 	disp_v16_hexlize
	add 	-1,d2
	bne 	disp_v16_bit4_15
disp_v16_end:
	add 	2,a3
	rts

disp_v16_hexlize:
	cmp 	0x000a,d1
	bge 	disp_v16_hexlize_a_f
disp_v16_hexlize_0_9:
	add 	0x0030,d1
	jmp 	disp_v16_hexlize_disp
disp_v16_hexlize_a_f:
	add 	0x0037,d1
disp_v16_hexlize_disp:
	add 	-8,a0
	jsr 	moji2vram4x8
	rts


#=========================
# DETECT TOUCH RECTANGLEs
#=========================
#`m̓蔻𓾂B
#()
#a0:`P(X1,Y1,X2,Y2) 8bytes
#a1:`Q(X3,Y3,X4,Y4) 8bytes
#d0:㉺̗Vт̑傫
#d1:E̗Vт̑傫
#(o)
#d3: 0(ڐG) /1(ڐG) /2(Փ)
#j
#4ʂɏꍇčlƕ邪A`mՓ˂ĂԂ́A
#1: X3<X2
#2: X4>X1
#3: Y4>Y1
#4: Y3<Y2
#1`4̏ɐ藧ƂB
#ڐGĂԂ́A=tAǂꂩł=ΐڐGɂȂB
#܂ARuputer̉tlāAۂɂ͏C

detect_touch_re:
	add 	-4,a3
	mov 	d0,(2,a3)
	mov 	d1,(0,a3)
	sub 	d3,d3 							#D3ڐGtO
detect_touch_re_rside: 						#E
	mov 	(4,a0),d0 						#X2
	add 	1,d0
	mov 	(0,a1),d1 						#X3
	mov 	(0,a3),d2
	sub 	d2,d0
	sub 	d0,d1
	bns 	detect_touch_re_lside 			#X3<X2
	bne 	detect_touch_re_end 			#X3>X2
	or 		1,d3 							#X3=X2 		tO
detect_touch_re_lside: 						#
	mov 	(0,a0),d0 						#X1
	add 	-1,d0
	mov 	(4,a1),d1 						#X4
	mov 	(0,a3),d2
	sub 	d2,d1
	sub 	d1,d0
	bns 	detect_touch_re_uside 			#X4>X1
	bne 	detect_touch_re_end 			#X4<X1
	or 		1,d3 							#X4=X1 		tO
detect_touch_re_uside: 						#
	mov 	(2,a0),d0 						#Y1
	add 	-1,d0
	mov 	(6,a1),d1 						#Y4
	mov 	(2,a3),d2
	sub 	d2,d1
	sub 	d1,d0
	bns 	detect_touch_re_dside 			#Y4>Y1
	bne 	detect_touch_re_end 			#Y4<Y1
	or 		1,d3 							#Y4=Y1 		tO
detect_touch_re_dside: 						#
	mov 	(6,a0),d0 						#Y2
	add 	1,d0
	mov 	(2,a1),d1 						#Y3
	mov 	(2,a3),d2
	sub 	d2,d0
	sub 	d0,d1
	bns 	detect_touch_re_touch 			#Y3<Y2
	bne 	detect_touch_re_end 			#Y3>Y2
	or 		1,d3 							#Y3=Y2 		tO
detect_touch_re_touch:
	btst 	0x01,d3
	bne 	detect_touch_re_touch_end
	mov 	2,d3 							#Փ
	add 	4,a3
	rts
detect_touch_re_touch_end: 					#ڐG
	mov 	1,d3
	add 	4,a3
	rts
detect_touch_re_end: 						#ڐG
	sub 	d3,d3
	add 	4,a3
	rts

#=========================
# DETECT INSIDE RECTANGLEs
#=========================
#`傫`̒ɂ邩ǂ߂
#()
#a0:`P(X1,Y1,X2,Y2) 8bytes (ɑ傫Ɓj
#a1:`Q(X3,Y3,X4,Y4) 8bytesiɏƁj
#(o)
#d3: 0(`Q͋`P̓) / 1(`Q͋`P̊OgɏdȂ) / 2(`Q͋`P̊O)
#j
#4ʂɏꍇčlƕ邪A`P̒ɋ`QԂ
#1: X3>X1
#2: X4<X2
#3: Y3>Y1
#4: Y4<Y2
#1`4̏ɐ藧ƂB
#ڐGĂԂ́Aǂꂩ = ɂȂƂB

detect_inside_re:
	sub 	d3,d3 							#D3ڐGtO
	mov 	1,d2 							#tOp萔
detect_inside_re_lside: 					#
	mov 	(0,a0),d0 						#X1
	mov 	(0,a1),d1 						#X3
	sub 	d0,d1
	cmp 	0,d1
	bgt 	detect_inside_re_rside
	blt 	detect_inside_re_2end
	or 		d2,d3 							#dȂ
detect_inside_re_rside: 					#E
	mov 	(4,a0),d0 						#X2
	mov 	(4,a1),d1 						#X4
	sub 	d1,d0
	cmp 	0,d0
	bgt 	detect_inside_re_uside
	blt 	detect_inside_re_2end
	or 		d2,d3 							#dȂ
detect_inside_re_uside: 					#
	mov 	(2,a0),d0 						#Y1
	mov 	(2,a1),d1 						#Y3
	sub 	d0,d1
	cmp 	0,d1
	bgt 	detect_inside_re_dside
	blt 	detect_inside_re_2end
	or 		d2,d3 							#dȂ
detect_inside_re_dside: 					#
	mov 	(6,a0),d0 						#Y2
	mov 	(6,a1),d1 						#Y4
	sub 	d1,d0
	cmp 	0,d0
	bgt 	detect_inside_re_touch
	blt 	detect_inside_re_2end
	or 		d2,d3 							#dȂ
detect_inside_re_touch:
	cmp 	1,d3
	beq 	detect_inside_re_1end
	sub 	d3,d3
	rts
detect_inside_re_1end:
	rts
detect_inside_re_2end:
	mov 	2,d3
	rts

#=========================
#	Randam LCG (with Time)
#=========================
#`@ɂ胉_Ȓl[IɓBݎ𗘗pB
#`@FA*B+CMŊ] -> X(_l)
#2ڂX̒lBɑB
#OIɂ́AĂяoD3Ƀ_Ȓl...Ax͒ႢB
#iój
#d3:_l
randam_lcgt:
	jsr 	reset_mdr_with_d0

	mov 	(randam_lcgt_flag),d2
	cmp 	1,d2
	beq 	randam_lcgt_2nd

	mov 	time_data_lcgt,a0
	jsr 	gettime

	mov 	(time_data_lcgt+6),d0 			#(BCD`Bȉ)
	mov 	(time_data_lcgt+8),d1 			#
	add 	d1,d0 							#+(A) 	#F0x000XɂȂƕ΂
randam_lcgt_1st:
	mov 	(time_data_lcgt+10),d1 			#(B)
	mov 	1,d2
	mov 	d2,(randam_lcgt_flag)
	jmp 	randam_lcgt2
randam_lcgt_2nd:
	mov 	(randam_lcgt_get_delay),d0
	add 	1,d0
	cmp	 	RANDAM_LCGT_DELAY_MAX,d0
	ble 	randam_lcgt_2nd2
	sub 	d0,d0
	mov 	d0,(randam_lcgt_get_delay)
	mov 	time_data_lcgt,a0
	jsr 	gettime
randam_lcgt_2nd2:
#	mov 	(time_data_lcgt+6),d0
	mov 	(time_data_lcgt+10),d0
	mov 	(time_data_lcgt+8),d1
	add 	d1,d0							#A
	add 	0x0fff,d0
	mov 	(randam_lcgt_seed),d1 			#X(B)
randam_lcgt2:
	mulu 	d0,d1 							#A*B
	mov 	(time_data_lcgt+12),d0
	mov 	(time_data_lcgt+10),d2			#𑫂x
	add 	d2,d0					 		#b(C)

	add 	d0,d1 							#D1:(A*B+C)
randam_lcgt3: 								#mod͏ȗ
	mov 	d1,d3 							#D3:X(_l)
randam_lcgt4:
	lsr 	d3 								#x̂߉4rbgr
	lsr 	d3
	lsr 	d3
	lsr 	d3
	extxu 	d3
	mov 	d3,(randam_lcgt_seed)
	jsr 	reset_mdr_with_d0
	rts

#pj̕΂
#randam_lcgt͓+AƂĂBBC𑫂Ɨ܂B
#B,C̎AAłĂ͋ɂȂBĂ̗͎BɂȂB
#̏ԂŁAA,CŒ肳ĂƂƁA
#C̎AxłBɂȂƁAƋłȂȂĂ܂B
#܂CƂ́A1:1ŉXƌJԂB
#EEEE
#ǋLj̃ASY̓tgƂŗɕ΂肪oB
#΂ϑ邽тɉlĂ....LIȂĂB
#ł͈Să[XłȂB̃[`͎̂Ēu..H
#EEEE
#ǋLjǂ珉l̂炵B
#AXOR Shift (with Time)܂Ă悤Ȃ̂Ō񂵁B

	.align 2
.lcomm time_data_lcgt		,14 			#LCGTpݎi[p
randam_lcgt_seed: 	.short 0
randam_lcgt_flag: 	.short 0 				#QbgۂB
randam_lcgt_get_delay: 	.short 0 			#gettime鎞ԍ
.equ 	RANDAM_LCGT_DELAY_MAX , 1 			#gettimeiyʉ̂߁j

#=========================
#	XOR Shift
#=========================
#`@ł͂ǂɂ܂Ȃ̂ō쐬B16bitłǁîHj
#(o)
#d3:_l
randam_xors:
randam_xors_xshift:
	mov 	(randam_xors_value_x),d0
	mov 	d0,d1
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0 							#x << 11
	xor 	d1,d0
	mov 	d0,(randam_xors_value_t)
randam_xors_mov:
	mov 	(randam_xors_value_y),d0
	mov 	d0,(randam_xors_value_x) 
	mov 	(randam_xors_value_z),d0
	mov 	d0,(randam_xors_value_y) 
	mov 	(randam_xors_value_w),d0
	mov 	d0,(randam_xors_value_z) 
randam_xors_wshift:
	mov 	(randam_xors_value_w),d0
	mov 	d0,d1
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0 							#w >> 19
	xor 	d1,d0 						#d0:set
randam_xors_tshift:
	mov 	(randam_xors_value_t),d1
	mov 	d1,d2
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1 							#t >> 8
	xor 	d2,d1 						#d1:set
randam_xors_wxort:
	xor 	d0,d1
	mov 	d1,(randam_xors_value_w)
	mov 	d1,d3
	rts

.align 2
randam_xors_value_t: 		.short 0
randam_xors_value_x:		.short 12345
randam_xors_value_y:		.short 36493
randam_xors_value_z:		.short 52128
randam_xors_value_w: 		.short 48675

#=========================
#	XOR Shift (with time)
#=========================
#Iɍrandam_xorsA16rbgłĊOHI
#gettime𐷂荞ŕςȂ^ς邱ƂɁB
#ij
#ȂȂɕzĂ悤ȁEEE
#(o)
#d3:_l
randam_xorst:
	mov 	(flag_xorst_2nd),d0
	cmp		1,d0
	beq 	randam_xorst_xshift
	mov 	time_data_xorst,a0
	jsr 	gettime
	mov 	(time_data_xorst+6),d0
	mov 	(time_data_xorst+8),d1
	mov 	(time_data_xorst+10),d2
	mov 	(time_data_xorst+12),d3
	add 	d0,d1
	add 	d1,d2
	add 	d2,d3
	mov 	(randam_xors_value_w),d0
	add 	d3,d0
	mov 	d0,(randam_xors_value_w)
	mov 	1,d0
	mov 	d0,(flag_xorst_2nd)
randam_xorst_xshift:
	mov 	(randam_xors_value_x),d0
	mov 	d0,d1
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0
	rol 	d0 							#x << 11 (Vtg̑Ƀ[e[gj
	xor 	d1,d0
	mov 	d0,(randam_xors_value_t)
randam_xorst_mov:
	mov 	(randam_xors_value_y),d0
	mov 	d0,(randam_xors_value_x) 
	mov 	(randam_xors_value_z),d0
	mov 	d0,(randam_xors_value_y) 
	mov 	(randam_xors_value_w),d0
	mov 	d0,(randam_xors_value_z) 
randam_xorst_wshift:
	mov 	(randam_xors_value_w),d0
	mov 	d0,d1
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0
	ror 	d0 							#w >> 19
	xor 	d1,d0 						#d0:set
randam_xorst_tshift:
	mov 	(randam_xors_value_t),d1
	mov 	d1,d2
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1
	ror 	d1 							#t >> 8
	xor 	d2,d1 						#d1:set
randam_xorst_wxort:
	xor 	d0,d1
	mov 	d1,(randam_xors_value_w)
	mov 	d1,d3
	rts

.align 2
randam_xorst_value_t: 		.short 0
randam_xorst_value_x:		.short 12345		#`p[mE萔Ƃ炵
randam_xorst_value_y:		.short 36493 		#}WbNio[Y
randam_xorst_value_z:		.short 52128
randam_xorst_value_w: 		.short 38675
time_data_xorst: 			.fill 14,1,0
flag_xorst_2nd: 			.short 0

#==================
#	GetTime (Xj
#==================
#NEEEEEb̃f[^RTCp̈(time_data)ɌĂяoB
#(11/2/2):19IɂΉ邱ƂɂB
#()
#a0:time_data


gettime:
	sub 	4,a3
	mov 	a0,(0,a3)
	mov 	BI_DTREAD,d0 			#wbiosR[:BI_DTREAD
	jsr 	call_wbios 				#tget(BCD)
	
	mov 	(0,a3),a0 				#ۑ̈擪AhX -> a0
#	mov 	0x20,d1 				#N2"20"ߑłB(20XX) *Cς*
	mov 	d2,d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	lsr 	d1
	mov 	0x00ff,d0
	and 	d0,d1 					#N2 19XXΉ
gettime_ymd_trans:
	jsr 	bcd2mem
	mov 	d2,d1 					#N2(bi_dtreadɂ擾)
	jsr 	bcd2mem
	mov 	d3,d1 					#
	jsr 	bcd2mem
	mov 	a1,d1 					#(AhXł͂Ȃ)
	jsr 	bcd2mem
gettime_hms:
	mov 	BI_TMREAD,d0 			#wbiosR[:BI_TMREAD
	jsr 	call_wbios  			#get!(BCD)

	mov 	(0,a3),a0 				#ۑ̈擪AhX -> a0
	add 	8,a0		 			#ăZbg
gettime_hms_trans:
	mov 	d2,d1 					#(bi_tmreadɂ擾)
	jsr 	bcd2mem
	mov 	d3,d1 					#
	jsr 	bcd2mem
	mov 	a1,d1 					#b(AhXł͂Ȃ)
	jsr 	bcd2mem
gettime_end:
	add 	4,a3
	rts

bcd2mem:
	mov 	d1,d0 					#d1j\h
	and 	0x000f,d0 				#ԉ1ȊO̓NA
	movb 	d0,(1,a0)
	ror 	d1 						#E[e[g
	ror 	d1
	ror 	d1
	ror 	d1 						#4bitsE
	and 	0x000f,d1
	movb 	d1,(0,a0) 				#i[
	add 	2,a0 					#␳
	rts

bcd2mem2:
	mov 	d1,d0
	

.align 2
	.lcomm time_data			,14 			#ݎi[p


#=========================
#   	CREATE MMP
#=========================
#VRAMۗLC[WMMP𓾂B
#SɔCӂ̈ʒuwł킯ł͂ȂBiy[W؂j
#()
#a0:VRAM擪
#a1:擾͈(0:X1 / 2:X2 / 4:Y1/8 / 6:Y2/8) 8bytes
#a2:MMPۑ̈ <-擾͈͂ɑ΂\ȗ̈mۂĂ
#
#                * Wƕϊ̊֌W *
#
#               X1,Y1*8---------X2,Y1*8
#                 |               |
#                 |     MMP     | <-W؂
#                 |               |
#                 --------------X2,Y2*8
#jX1X2ŕwBYōw肷B
#Y1,Y2(0`8)܂ŁBۂYW͂ɂWlƂȂB
#܂X2,Y2X1,Y1傫KvB
#Cӂ̈ʒuɂ邱Ƃł邪AᑬSzȂ̂ŐtƂȂB

	.equ 	PAGE_MAX ,102


create_mmp:
	add 	-8,a3
	mov 	(0,a1),d0
	mov 	(4,a1),d1
	sub 	d0,d1
	mov 	d1,(0,a2) 							#dX (X-size)
	mov 	d1,(2,a3)
	
	mov 	(2,a1),d0
	mov 	(6,a1),d1
	sub 	d0,d1
	mov 	d1,(0,a3) 							#[vJE^

	add 	d1,d1 		#x2
	add 	d1,d1 		#x4
	add 	d1,d1 		#x8
	mov 	d1,(2,a2) 							#dY (Y-size) wb_!
	add 	4,a2
create_mmp_fixvram:
	mov 	(0,a1),d0
	add 	d0,a0 								#+X
	mov 	(2,a1),d0
	mov 	PAGE_MAX,d1
	mulu 	d1,d0
	add	 	d0,a0 								#+Y
	mov 	a0,(4,a3)
create_mmp_convert:
	mov 	(0,a3),d3 							#YJE^
create_mmp_convert2:
	mov 	(2,a3),d2 							#XJE^
create_mmp_convert3:
	movbu 	(0,a0),d0
	movb 	d0,(0,a2)
	add 	1,a0
	add 	1,a2
	add 	-1,d2
	bne 	create_mmp_convert3
create_mmp_convert4:
	mov 	(4,a3),a0
	add 	PAGE_MAX,a0
	mov 	a0,(4,a3)
	add 	-1,d3
	bne 	create_mmp_convert2
create_mmp_convert_end:
	add 	8,a3
	rts

#================
# Draw Square
#================
#draw line clone pĉʂɎlp``
#()
#a0: VRAM擪
#a1: (0:x1 / 2:y1 / 4:x2 / 6:y2) : 8bytes 
#
#                * WVRAM̊֌W *
#
#               X1,Y1--------------
#                 |               |
#                 |     VRAM      |
#                 |               |
#                 --------------X2,Y2
#(x1,y1)n_B(x2,y2)I_Bslӌ`ɂ͑ΉȂB

draw_square:
	sub 	12,a3
	mov 	(0,a1),d0
	mov 	d0,(0,a3)
	mov 	(2,a1),d0
	mov 	d0,(2,a3)
	mov 	(4,a1),d0
	mov 	d0,(4,a3)
	mov 	(6,a1),d0
	mov 	d0,(6,a3)
	mov 	a0,(8,a3)
draw_square_up: 							#X1,Y1 --- X2,Y1
	mov 	(0,a1),d0
	mov 	d0,(draw_square_workarea)
	mov 	(2,a1),d0
	mov 	d0,(draw_square_workarea+2)
	mov 	(4,a1),d0
	mov 	d0,(draw_square_workarea+4)
	mov 	(2,a1),d0
	mov 	d0,(draw_square_workarea+6)
	mov 	draw_square_workarea,a1
	jsr 	draw_linec
draw_square_dw: 							#X1,Y2 --- X2,Y2
	mov 	(0,a3),d0
	mov 	d0,(draw_square_workarea)
	mov 	(6,a3),d0
	mov 	d0,(draw_square_workarea+2)
	mov 	(4,a3),d0
	mov 	d0,(draw_square_workarea+4)
	mov 	(6,a3),d0
	mov 	d0,(draw_square_workarea+6)
	mov 	(8,a3),a0
	mov 	draw_square_workarea,a1
	jsr 	draw_linec
draw_square_lf: 							#X1,Y1 --- X1,Y2
	mov 	(0,a3),d0
	mov 	d0,(draw_square_workarea)
	mov 	(2,a3),d0
	mov 	d0,(draw_square_workarea+2)
	mov 	(0,a3),d0
	mov 	d0,(draw_square_workarea+4)
	mov 	(6,a3),d0
	mov 	d0,(draw_square_workarea+6)
	mov 	(8,a3),a0
	mov 	draw_square_workarea,a1
	jsr 	draw_linec
draw_square_rg: 							#X2,Y1 --- X2,Y2
	mov 	(4,a3),d0
	mov 	d0,(draw_square_workarea)
	mov 	(2,a3),d0
	mov 	d0,(draw_square_workarea+2)
	mov 	(4,a3),d0
	mov 	d0,(draw_square_workarea+4)
	mov 	(6,a3),d0
	mov 	d0,(draw_square_workarea+6)
	mov 	(8,a3),a0
	mov 	draw_square_workarea,a1
	jsr 	draw_linec
draw_square_end:
	add 	12,a3
	rts

.align 2
	.lcomm	draw_square_workarea		,	8

#================
#Draw Line Clone
#================
#`_a_ɒBu[n@gB
#MIRÓwC[`xɂčĂ邪AFXƓeقȂ(?)B
#ȏgĂBRAMp̂߂̃P[^u͖B
#()
#a0: VRAM擪
#a1: (0:x1 / 2:y1 / 4:x2 / 6:y2) : 8bytes 
#
#                * WVRAM̊֌W *
#
#      VRAM擪==>0------------X+ (MAX 101)
#                 |
#                 |    VRAM
#                 |
#                 Y+ (MAX 63)
#
#) Y͉ɐLт邪ł͂ȂƂB̐ɂ͑ΉȂB
#    ) ܂A(0,0)͉ʍ[̃hbgƂđ݂ĂB
#
#d3:tOp ( 1:X1<X2 / 2:Y1<Y2 )
#
#iRgj
#܂܂̒Ƃô...
#ǂƕ΂肪悤ɌBX␮ɃoOۂB
#܂AMIRÔ̂Ƃ͈ႢAX1,Y1`ʂB


.equ 		VRAM_LINE_MAX 		, 102 		#VRAM̃Ci:ʏ102j
.equ 		VRAM_PAGE_MAX 		, 8 		#VRAM̃y[Wic:ʏ 8 j
.equ 		VRAM_BIT_PER_LINE 	, 8 		#1LINEBIT(ʏ 8 )

draw_linec:
	sub 	4,a3
	mov 	draw_line_shifttable,a2
	sub 	d3,d3
draw_linec_x:
	mov 	(0,a1),d0
	mov 	(4,a1),d1
	sub 	d1,d0
	bcc 	draw_linec_x2
	sub 	d1,d1
	sub 	d0,d1 							#]
	mov 	d1,d0
	or 		1,d3 							#D3 : "1" flag
draw_linec_x2:
	add 	1,d0 							#C (Ⴆ΋SȂhbg͂T邩)
	mov 	d0,(0,a3) 						#Xm
	movb 	d0,(draw_linec_xbase_up3+1)
	movb 	d0,(draw_linec_xbase_up4+2)
	movb 	d0,(draw_linec_xbase_dw3+1)
	movb 	d0,(draw_linec_xbase_dw4+2)
	movb 	d0,(draw_linec_ybase_dw3_2+1)
	movb 	d0,(draw_linec_ybase_up3_2+1)

draw_linec_y:
	mov 	(2,a1),d0
	mov 	(6,a1),d1
	sub 	d1,d0
	bcc 	draw_linec_y2
	sub 	d1,d1
	sub 	d0,d1 							#]
	mov 	d1,d0
	or 		2,d3 							#D3 : "2" flag  )"1"ƏdL
draw_linec_y2:
	add 	1,d0
	mov 	d0,(2,a3) 						#Ym
	movb 	d0,(draw_linec_xbase_up2_3+1)
	movb 	d0,(draw_linec_xbase_dw2_3+1)
	movb 	d0,(draw_linec_ybase_dw4+1)
	movb 	d0,(draw_linec_ybase_dw5+2)
	movb 	d0,(draw_linec_ybase_up4+1)
	movb 	d0,(draw_linec_ybase_up5+2)
	
draw_linec_x_or_y: 							#XYǂ炪傫ŕ
	mov 	(0,a3),d0
	mov 	(2,a3),d1
	cmp 	d0,d1
	bge 	draw_linec_ybase 				#X =< Y -> Yx[X

draw_linec_xbase:
	mov 	(0,a1),d0 						# X1
	mov 	(2,a1),d1 						# Y1 )X1,Y1BX2,Y2ւ̐؂ւ͂ȂB
draw_linec_xbase_vram: 						# XY̒lVRAM␮
	add 	d0,a0 							# X␮
draw_linec_xbase_vram_loop:
	cmp 	VRAM_BIT_PER_LINE,d1 			
	blt 	draw_linec_xbase_vram_loop_end	# Y␮KvȂꍇ/␮Iꍇ
draw_linec_xbase_vram_loop2:
	add 	VRAM_LINE_MAX,a0
	sub 	VRAM_BIT_PER_LINE,d1
	jmp 	draw_linec_xbase_vram_loop
draw_linec_xbase_vram_loop_end:

draw_linec_xbase_check: 					#Qlj̍s
						  					#_^:btst(!2) btst(!1):_ btst(1):^
											#^_:btst( 2) btst(!1):^ btst(1):_
	mov 	1,a1 							#sorts
	btst 	1,d3
	bne 	draw_linec_xbase_check1
	mov 	-1,a1
draw_linec_xbase_check1:
	mov 	d1,d2 							#d2͐̃e[uQƗp
	extxu 	d2
	btst 	2,d3
	bne 	draw_linec_xbase_dw 			#"2" ->^_
draw_linec_xbase_up: 						#_^
draw_linec_xbase_up1:
	movbu 	(d2,a2),d3 						#d3:e[uQƂrbgC[W
	mov 	(0,a3),d1 						#[vJE^
	sub 	d2,d2 							#u[n@pJE^
draw_linec_xbase_up2:
	jsr 	draw_linec_fake_draw_x
	jsr 	draw_linec_fake_draw_x
#	jsr 	draw_linec_fake_draw_x
#	jsr 	draw_linec_fake_draw_x
draw_linec_xbase_up2_2:
	movb 	(0,a0),d0
	or 		d3,d0
	movb 	d0,(0,a0)
	add 	a1,a0
draw_linec_xbase_up2_3:
#	mov 	(2,a3),d0
#	add 	d0,d2 							#+Y
	add 	0x1,d2 							#+Y
draw_linec_xbase_up3:
#	mov 	(0,a3),d0
#	cmp 	d0,d2 							#d2Xr
	cmp 	0x2,d2 							#d2Xr
	blt 	draw_linec_xbase_up5
draw_linec_xbase_up4:
#	mov 	(0,a3),d0
#	sub 	d0,d2
	sub 	0x2,d2 							#X
	ror 	d3 								#irbgŁjփ[Bʂł͏Ƀ[
	bcc 	draw_linec_xbase_up5 			#Ƀ[d؂ĂȂΎ
	mov 	0b10000000,d3 					#ԉŃZbg
	extxu 	d3
	sub 	VRAM_LINE_MAX,a0
draw_linec_xbase_up5:
	sub 	1,d1
	bne 	draw_linec_xbase_up2_2
	add 	4,a3
	rts

draw_linec_xbase_dw: 						#^_
draw_linec_xbase_dw1:
	not 	d3
	movbu 	(d2,a2),d3 						#d3:e[uQƂrbgC[W
	mov 	(0,a3),d1
	sub 	d2,d2
draw_linec_xbase_dw2:
	jsr 	draw_linec_fake_draw_x
	jsr 	draw_linec_fake_draw_x
#	jsr 	draw_linec_fake_draw_x
draw_linec_xbase_dw2_2:
	movb 	(0,a0),d0
	or 		d3,d0
	movb 	d0,(0,a0)
	add 	a1,a0
draw_linec_xbase_dw2_3:
#	mov 	(2,a3),d0
#	add 	d0,d2
	add 	0x1,d2 							#Y
draw_linec_xbase_dw3:
#	mov 	(0,a3),d0
#	cmp 	d0,d2
	cmp 	0x2,d2 							#X
	blt 	draw_linec_xbase_dw5
draw_linec_xbase_dw4:
#	mov 	(0,a3),d0
#	sub 	d0,d2
	sub 	0x2,d2 							#X
	extxb 	d3
	rol 	d3 								#up̏ꍇ̋t
	bcc 	draw_linec_xbase_dw5
	mov 	0b00000001,d3
	extxu 	d3
	add 	VRAM_LINE_MAX,a0
draw_linec_xbase_dw5:
	sub 	1,d1
	bne 	draw_linec_xbase_dw2_2
	add 	4,a3
	rts

draw_linec_fake_draw_x: 					#ǂ݂郋[`
	mov 	(6,a3),d0 						#Xx[XDX>DY̎Ȃ̂ŁAnD2̂Ƃ͒܂ȂB
	add 	d0,d2 							#̂ߑ̏ꍇQ񓯂hbgłĂ܂B
draw_linec_fake_draw_x2: 					#ʓ|[ǂ݂Ď̂ႨƂƁB
	mov 	(4,a3),d0
	cmp 	d0,d2
	blt 	draw_linec_fake_draw_x4
draw_linec_fake_draw_x3:
	mov 	(4,a3),d0
	sub 	d0,d2
	rts
draw_linec_fake_draw_x4:
	jmp 	draw_linec_fake_draw_x


draw_linec_ybase: 							#<-- draw_linec_x_or_y
	mov 	(0,a1),d0 						# X1
	mov 	(2,a1),d1 						# Y1
draw_linec_ybase_vram: 						# XY̒lVRAM␮
	add 	d0,a0 							# X␮
draw_linec_ybase_vram_loop:
	cmp 	VRAM_BIT_PER_LINE,d1 			
	blt 	draw_linec_ybase_vram_loop_end	# Y␮KvȂꍇ/␮Iꍇ
draw_linec_ybase_vram_loop2:
	add 	VRAM_LINE_MAX,a0
	sub 	VRAM_BIT_PER_LINE,d1
	jmp 	draw_linec_ybase_vram_loop
draw_linec_ybase_vram_loop_end:
	mov 	d1,d2
	extxu 	d2
	mov 	1,a1
	btst 	1,d3 							#Xŏsts߂ĂB
	bne 	draw_linec_ybase2
	mov 	-1,a1
draw_linec_ybase2:
	btst 	2,d3
	beq 	draw_linec_ybase_up 			#"2łȂ"ꍇ -> _^
draw_linec_ybase_dw: 						#^_
	movbu 	(d2,a2),d3
	mov 	(2,a3),d1
	sub 	d2,d2
draw_linec_ybase_dw2:
	jsr 	draw_linec_fake_draw_y
#	jsr 	draw_linec_fake_draw_y
#	jsr 	draw_linec_fake_draw_y
draw_linec_ybase_dw3:
	movb 	(0,a0),d0
	or 		d3,d0
	movb 	d0,(0,a0)
draw_linec_ybase_dw3_2:
#	mov 	(0,a3),d0
#	add 	d0,d2
	add 	0x2,d2 							#X
	extxb 	d3 								#[͕KN_ɒӁB
	rol 	d3
	bcc 	draw_linec_ybase_dw4
	mov 	0b00000001,d3
	add 	VRAM_LINE_MAX,a0
draw_linec_ybase_dw4:
#	mov 	(2,a3),d0
#	cmp 	d0,d2
	cmp 	0x1,d2
	blt 	draw_linec_ybase_dw6
draw_linec_ybase_dw5:
#	mov 	(2,a3),d0
#	sub 	d0,d2
	sub 	0x1,d2
	add 	a1,a0
draw_linec_ybase_dw6:
	sub 	1,d1
	bne 	draw_linec_ybase_dw3
	add 	4,a3
	rts

draw_linec_ybase_up: 						#_^
	movbu 	(d2,a2),d3
	mov 	(2,a3),d1
	sub 	d2,d2
draw_linec_ybase_up2_2:
	jsr 	draw_linec_fake_draw_y
draw_linec_ybase_up3:
	movb 	(0,a0),d0
	or 		d3,d0
	movb 	d0,(0,a0)
draw_linec_ybase_up3_2:
#	mov 	(0,a3),d0
#	add 	d0,d2
	add 	0x1,d2
	ror 	d3
	bcc 	draw_linec_ybase_up4
	mov 	0b10000000,d3
	sub 	VRAM_LINE_MAX,a0
draw_linec_ybase_up4:
#	mov 	(2,a3),d0
#	cmp 	d0,d2
	cmp 	0x1,d2
	blt 	draw_linec_ybase_up6
draw_linec_ybase_up5:
#	mov 	(2,a3),d0
#	sub 	d0,d2
	sub 	0x1,d2
	add 	a1,a0
draw_linec_ybase_up6:
	sub 	1,d1
	bne 	draw_linec_ybase_up3
	add 	4,a3
	rts


draw_linec_fake_draw_y: 					#x̏ꍇƈӖ͓B
	mov 	(4,a3),d0
	add 	d0,d2 							#+Y
draw_linec_fake_draw_y2:
	mov 	(6,a3),d0
	cmp 	d0,d2 							#d2Xr
	blt 	draw_linec_fake_draw_y4
draw_linec_fake_draw_y3:
	mov 	(6,a3),d0
	sub 	d0,d2
	rts
draw_linec_fake_draw_y4:
	jmp 	draw_linec_fake_draw_y


.align 2
draw_line_shifttable:
	.byte 	0b00000001,0b00000010,0b00000100,0b00001000,0b00010000,0b00100000,0b01000000,0b10000000



#==============================
# 		BCD  to   BIN
#==============================
##BCD`̃f[^ʏ̐ɕϊB
#()
#a1:BCD̃f[^(2bytes)
#d3:ϊBINf[^
bcd2bin:
	movbu 	(0,a1),d3
	movbu 	(1,a1),d1
	mov 	10,d0
	mulu 	d0,d3
	add 	d1,d3
	sub 	d0,d0
	mov 	d0,mdr
	rts



#=========================
# 	 DRAW MMP (MASK)
#=========================
#y[W܂MMP`ʂB
#_maskƕtƃ}XNp̕`ʂɐ؂ւB
#()
#a0:VRAM擪
#a1:MMP ([łȂwb_2+2bytesK邱Ɓj
#a2:o͐XW(0-101) , YW(0-63) i[4bytes̗̈
#
#jI[o[t[͎ŌvZĂˁB

	.equ 	COLUMN_BIT , 8
	.equ 	COLUMN_MAX , 102
	.equ 	VRAM_SIZE_LIMIT , 102*8

draw_mmp_mask:
	add 	-20,a3
	mov 	a0,(a3)
	
	add 	VRAM_SIZE_LIMIT,a0
	mov 	a0,d0
	mov 	d0,(draw_mmp_bitdw_2+1) 		#ȏ
	mov 	d0,(draw_mmp_bitup+1) 			#ȏ

	mov 	(0,a2),d2
	mov 	(2,a2),d3

	mov 	d2,(12,a3)
	mov 	d3,(14,a3)

	mov 	(0,a1),d0 						#d0:Xwb_
	mov 	d0,(8,a3)

	mov 	(2,a1),d1
	mov 	COLUMN_BIT,d0
	divu 	d0,d1
	mov 	mdr,d0
	cmp 	0,d0
	beq 	draw_mmp_mask2
	add 	1,d1
draw_mmp_mask2:
	mov 	d1,(10,a3)						#d1:Ywb_
	sub 	d0,d0
	mov 	d0,mdr

	add 	4,a1 							#wb_i߂
	mov 	a1,(4,a3)

	mov 	(draw_mmp_mask_mask),d0 		 #***  CAUTION! ***
	mov 	d0,(draw_mmp_bitup_end_2)	 	 # ȏ
	mov 	d0,(draw_mmp_bitdw4_2)
	mov 	(draw_mmp_mask_mask+2),d0
	mov 	d0,(draw_mmp_bitup_end_2+2)
	mov 	d0,(draw_mmp_bitdw4_2+2)
	mov 	(draw_mmp_mask_mask+4),d0
	mov 	d0,(draw_mmp_bitup_end_2+4)
	mov 	d0,(draw_mmp_bitdw4_2+4)

	mov 	(a3),a0
	mov 	(4,a3),a1
	mov 	(8,a3),d0
	mov 	(10,a3),d1
	mov 	(12,a3),d2
	mov 	(14,a3),d3
	jmp 	draw_mmp2

#=====CODE DATA======#
	.align 2
draw_mmp_mask_mask:
	mov 	d1,d2 						#1
	nop 								#1
	xor 	d0,d1						#2
	and 	d2,d1						#2(byte)
#=====FOR MODIFY=====#

draw_mmp:
	add 	-20,a3
	mov 	a0,(a3)

	add 	VRAM_SIZE_LIMIT,a0
	mov 	a0,d0
	mov 	d0,(draw_mmp_bitdw_2+1) 		#ȏ
	mov 	d0,(draw_mmp_bitup+1) 			#ȏ

	mov 	(0,a2),d2
	mov 	(2,a2),d3

	mov 	d2,(12,a3)
	mov 	d3,(14,a3)

	mov 	(0,a1),d0 						#d0:Xwb_
	mov 	d0,(8,a3)

	mov 	(2,a1),d1
	mov 	COLUMN_BIT,d0
	divu 	d0,d1
	mov 	mdr,d0
	cmp 	0,d0
	beq 	draw_mmp_2
	add 	1,d1
draw_mmp_2:
	mov 	d1,(10,a3)						#d1:Ywb_
	sub 	d0,d0
	mov 	d0,mdr

	add 	4,a1 							#wb_i߂
	mov 	a1,(4,a3)

	mov 	(draw_mmp_normal),d0 		 #***  CAUTION! ***
	mov 	d0,(draw_mmp_bitup_end_2)	 #  ȏ
	mov 	d0,(draw_mmp_bitdw4_2)
	mov 	(draw_mmp_normal+2),d0
	mov 	d0,(draw_mmp_bitup_end_2+2)
	mov 	d0,(draw_mmp_bitdw4_2+2)
	mov 	(draw_mmp_normal+4),d0
	mov 	d0,(draw_mmp_bitup_end_2+4)
	mov 	d0,(draw_mmp_bitdw4_2+4)

	mov 	(a3),a0
	mov 	(4,a3),a1
	mov 	(8,a3),d0
	mov 	(10,a3),d1
	mov 	(12,a3),d2
	mov 	(14,a3),d3
	jmp 	draw_mmp2

#=====CODE DATA======#
	.align 2
draw_mmp_normal:
	or 		d0,d1
	nop
	nop
	nop
	nop
#=====FOR MODIFY=====#

draw_mmp2:
	sub 	d0,d0
	cmp 	0,d3
	beq 	draw_mmp3
	mov 	d0,mdr
	mov 	COLUMN_BIT,d0
	divu 	d0,d3
	mov 	mdr,d0 						#Remainder
	sub 	d2,d2
	mov 	d2,mdr
	mov 	102,d2
	mulu 	d2,d3
	add 	d3,a0
draw_mmp3:
	mov 	d0,(16,a3)
draw_mmp3_2:
	mov 	(12,a3),d2
	add 	d2,a0
	mov 	a0,(a3) 					#FIX
draw_mmp4:
	mov 	(a3),a0 					#a0:VRAM
#	mov 	(4,a3),a1 					#a1:BITMAP
	mov 	(8,a3),d2 					#d2:X-SIZE
	jmp 	draw_mmp_bitup
	.align 2
	nop
draw_mmp_bitup: 						##<< UP
	cmp 	0x111,a0
	bge 	draw_mmp_end

	movbu 	(0,a1),d0
	mov 	(16,a3),d3
	mov 	0xfe,d1
	cmp 	0,d3
	beq 	draw_mmp_bitup_end
draw_mmp_bitup2:
	rol 	d0 							#dw..dw..
	and 	d1,d0 						#clear bit-0
	add 	-1,d3
	bne 	draw_mmp_bitup2
draw_mmp_bitup_end:
	movbu 	(0,a0),d1
	mov 	d2,(18,a3)
	jmp 	draw_mmp_bitup_end_2
	.align 2
draw_mmp_bitup_end_2:
	or 		d0,d1
	nop
	nop
	nop
	nop
	mov 	(18,a3),d2
	movb 	d1,(0,a0)
draw_mmp_bitdw: 						##<< DW
	add 	COLUMN_MAX,a0
	jmp 	draw_mmp_bitdw_2 			#<- align ŌԂł̂łjmp
	.align 2
	nop 								#<- ΏۂԒnɂȂ悤
draw_mmp_bitdw_2:
	cmp 	0x111,a0 						#a0 + imm16(Low) + imm16(High)
										#     ȏ2oCgڈȍ~
	bge 	draw_mmp_bitdw_end 			### VRAME𒴂牺͕`ʂȂ
draw_mmp_bitdw2:
	movbu 	(0,a1),d0
	mov 	(16,a3),d3
	cmp 	0,d3
	beq 	draw_mmp_bitdw_end
	mov 	COLUMN_BIT,d1
	sub 	d3,d1
	mov 	d1,d3
	mov 	0x7f,d1
draw_mmp_bitdw3:
	lsr 	d0 							#up..up..
	and 	d1,d0 						#clear bit-7
	add 	-1,d3
	bne 	draw_mmp_bitdw3
draw_mmp_bitdw4:
	movbu 	(0,a0),d1
	mov 	d2,(18,a3)
	jmp 	draw_mmp_bitdw4_2
	.align 2
draw_mmp_bitdw4_2:
	or 		d0,d1
	nop
	nop
	nop
	nop
	mov 	(18,a3),d2
	movb 	d1,(0,a0)
draw_mmp_bitdw_end:
	add 	1,a1
	sub 	COLUMN_MAX-1,a0
	add 	-1,d2
	bne 	draw_mmp_bitup
draw_mmp_ycheck:
	mov 	(10,a3),d3
	add 	-1,d3
	beq 	draw_mmp_end
draw_mmp_continue:
	mov 	d3,(10,a3)
	mov 	(a3),a0
	add 	COLUMN_MAX,a0
	mov 	a0,(a3)
	jmp 	draw_mmp4
draw_mmp_end:
	add 	20,a3
	rts



#================
# Draw Reverse
#================
#w͈͓o[XB̂ق̗̈󂳂ȂB
#reverse_areȁʔ....AR[hĂB
#ύlȂłƑʖڂˁ`Bd傫̌ʁB
#()
#a0: VRAM擪
#a1: (0:x1 / 2:y1 / 4:x2 / 6:y2) : 8bytes 
#
#              * WREVERSE̊֌W *
#
#               X1,Y1--------------
#                 |               |
#                 |    REVERSE    |
#                 |               |
#                 --------------X2,Y2
#(x1,y1)n_B(x2,y2)I_
#ӁjX2,y2͏x1,y1傫Ȃ΂ȂȂB <---
#      Ή邱Ƃł邪AɃR[h傫ȂCȊ

.equ 		VRAM_LINE_MAX 		, 102 		#VRAM̃Ci:ʏ102j
.equ 		VRAM_PAGE_MAX 		, 8 		#VRAM̃y[Wic:ʏ 8 j
.equ 		VRAM_BIT_PER_LINE 	, 8 		#1LINEBIT(ʏ 8 )

draw_reverse:
	sub 	24,a3
	mov 	a0,(0,a3)
	mov 	a1,(4,a3)
	sub 	d3,d3
	mov 	d3,mdr

draw_reverse2:
	mov 	(2,a1),d1 				#Y1
	mov 	VRAM_BIT_PER_LINE,d0
	cmp 	0,d1
	beq 	draw_reverse2_zero
	divu 	d0,d1
	mov 	mdr,d0
	mov 	d0,(10,a3)
	add 	1,d1
	mov 	d1,d3
	jmp 	draw_reverse3
draw_reverse2_zero:
	mov 	1,d3
	sub 	d0,d0
	mov 	d0,(10,a3)
draw_reverse3:
	mov 	d3,(8,a3)
	sub 	d0,d0
	mov 	d0,mdr


draw_reverse_dy_zero:
	mov 	(2,a1),d1
	mov 	(6,a1),d2
	cmp 	d1,d2
	bne 	draw_reverse3_2
	add 	1,d2

draw_reverse3_2:
	mov 	(6,a1),d2 				#Y2
	mov 	VRAM_BIT_PER_LINE,d0
	cmp 	0,d2
	beq 	draw_reverse3_zero
	divu 	d0,d2
	mov 	mdr,d0
	mov 	d0,(14,a3)
	add 	1,d2
	jmp 	draw_reverse4
draw_reverse3_zero:
	mov 	1,d2
	sub 	d0,d0
	mov 	d0,(14,a3)
draw_reverse4:
	mov 	d2,(12,a3)
	sub 	d0,d0
	mov 	d0,mdr
	
	mov 	(0,a1),d0
	mov 	(4,a1),d1
	sub 	d0,d1

	cmp 	0,d1
	bne 	draw_reverse4_2
	mov 	1,d1 					#ŒłP͂
draw_reverse4_2:
	add 	1,d1 															#*
	mov 	d1,(16,a3) 				#XƂĂ
draw_reverse_mode_check: 			#d3(Y1) , d2(Y2)
	mov 	1,d0 					#PFPy[WɎ܂Ă
	mov 	d0,(draw_reverse_mode)
	cmp 	d2,d3
	beq 	draw_reverse_vramfix
	mov 	2,d0 					#QFQȏł
	mov 	d0,(draw_reverse_mode)
	sub 	d3,d2
	mov 	d2,(22,a3) 				#y[W
draw_reverse_vramfix:
	mov 	(0,a1),d0
	mov 	(0,a3),a0
	add 	d0,a0
	mov 	(8,a3),d2
	add 	-1,d2
draw_reverse_vramfix_2:
	cmp 	0,d2
	beq 	draw_reverse_vramfix_3
	add 	VRAM_LINE_MAX,a0
	add 	-1,d2
	jmp 	draw_reverse_vramfix_2
draw_reverse_vramfix_3:
	mov 	a0,(18,a3)

	mov 	(draw_reverse_mode),d0
	cmp 	1,d0
	beq 	draw_reverse_mode1
	cmp 	2,d0
	beq 	draw_reverse_mode2
	jmp 	draw_reverse_mode2
draw_reverse_mode1: 							#Py[W
	mov 	(18,a3),a0
	mov 	(16,a3),d3							#d3:JE^
draw_reverse_model1_1:
	mov 	draw_reverse_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	movbu 	(0,a0),d0
	and 	d0,d2

	mov 	draw_reverse_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d0 							#d2-y2 save
	mov 	d0,d1
	movbu 	(0,a0),d0
	and 	d0,d1
	or 		d1,d2
	mov 	d2,a1 								#ۑ
	
	movb 	(0,a0),d0
	not 	d0
	mov 	draw_reverse_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	not 	d2
	and 	d2,d0

	mov 	draw_reverse_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	not 	d2
	and 	d2,d0
	
	mov 	a1,d1
	or 		d1,d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_reverse_model1_2:
	add 	1,a0
	add 	-1,d3
	bne 	draw_reverse_model1_1
	add 	24,a3
	rts

draw_reverse_mode2:
	mov 	(18,a3),a0
	mov 	(16,a3),d3							#d3:JE^
draw_reverse_model2_1:
	mov 	draw_reverse_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	movbu 	(0,a0),d0
	and 	d0,d2
	mov 	d2,a1 								#ۑ
	
	movb 	(0,a0),d0
	not 	d0
	mov 	draw_reverse_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 clear
	not 	d2
	and 	d2,d0
	
	mov 	a1,d1
	or 		d1,d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_reverse_model2_2:
	add 	1,a0
	add 	-1,d3
	bne 	draw_reverse_model2_1

draw_reverse_middle:
	mov 	(22,a3),d3
draw_reverse_middle2:
	add 	-1,d3
	beq 	draw_reverse_mode2_3

	mov 	(18,a3),a0
	add 	VRAM_LINE_MAX,a0
	mov 	a0,(18,a3)

	mov 	(16,a3),d2
draw_reverse_middle3:
	movb 	(0,a0),d0
	not 	d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_reverse_middle4:
	add 	1,a0
	add 	-1,d2
	bne 	draw_reverse_middle3
draw_reverse_middle5:
	jmp 	draw_reverse_middle2

draw_reverse_mode2_3:
	mov 	(18,a3),a0
	add 	VRAM_LINE_MAX,a0
	mov 	(16,a3),d3							#d3:JE^
draw_reverse_model2_4:
	mov 	draw_reverse_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d2 							#d2-y2 save
	movbu 	(0,a0),d0
	and 	d0,d2
	mov 	d2,a1 								#ۑ
	
	movb 	(0,a0),d0
	not 	d0
	mov 	draw_reverse_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d2 							#d2-y2 clear
	not 	d2
	and 	d2,d0
	
	mov 	a1,d1
	or 		d1,d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_reverse_model2_5:
	add 	1,a0
	add 	-1,d3
	bne 	draw_reverse_model2_4
	add 	24,a3
	rts

.align 2
draw_reverse_mode: 	.short 0
draw_reverse_y1_save_table:
	.byte 	0b00000000,0b00000001,0b00000011,0b00000111,0b00001111,0b00011111,0b00111111,0b01111111
draw_reverse_y2_save_table:
	.byte 	0b11111110,0b11111100,0b11111000,0b11110000,0b11100000,0b11000000,0b10000000,0b00000000



#================
# Draw Block
#================
#w͈͓lp`ɓhԂB̂ق̗̈󂳂ȂB
#()
#a0: VRAM擪
#a1: (0:x1 / 2:y1 / 4:x2 / 6:y2) : 8bytes 
#
#              * WREVERSE̊֌W *
#
#               X1,Y1--------------
#                 |               |
#                 |       1       |
#                 |               |
#                 --------------X2,Y2
#(x1,y1)n_B(x2,y2)I_
#ӁjX2,y2͏x1,y1傫Ȃ΂ȂȂB <---

.equ 		VRAM_LINE_MAX 		, 102 		#VRAM̃Ci:ʏ102j
.equ 		VRAM_PAGE_MAX 		, 8 		#VRAM̃y[Wic:ʏ 8 j
.equ 		VRAM_BIT_PER_LINE 	, 8 		#1LINEBIT(ʏ 8 )



draw_block:
	sub 	24,a3
	mov 	a0,(0,a3)
	mov 	a1,(4,a3)
	sub 	d3,d3
	mov 	d3,mdr

draw_block2:
	mov 	(2,a1),d1 				#Y1
	mov 	VRAM_BIT_PER_LINE,d0
	cmp 	0,d1
	beq 	draw_block2_zero
	divu 	d0,d1
	mov 	mdr,d0
	mov 	d0,(10,a3)
	add 	1,d1
	mov 	d1,d3
	jmp 	draw_block3
draw_block2_zero:
	mov 	1,d3
	sub 	d0,d0
	mov 	d0,(10,a3)
draw_block3:
	mov 	d3,(8,a3)
	sub 	d0,d0
	mov 	d0,mdr


draw_block_dy_zero:
	mov 	(2,a1),d1
	mov 	(6,a1),d2
	cmp 	d1,d2
	bne 	draw_block3_2
	add 	1,d2

draw_block3_2:
	mov 	(6,a1),d2 				#Y2
	mov 	VRAM_BIT_PER_LINE,d0
	cmp 	0,d2
	beq 	draw_block3_zero
	divu 	d0,d2
	mov 	mdr,d0
	mov 	d0,(14,a3)
	add 	1,d2
	jmp 	draw_block4
draw_block3_zero:
	mov 	1,d2
	sub 	d0,d0
	mov 	d0,(14,a3)
draw_block4:
	mov 	d2,(12,a3)
	sub 	d0,d0
	mov 	d0,mdr
	
	mov 	(0,a1),d0
	mov 	(4,a1),d1
	sub 	d0,d1

	cmp 	0,d1
	bne 	draw_block4_2
	mov 	1,d1 					#ŒłP͂
draw_block4_2:
	add 	1,d1 					#FIX
	mov 	d1,(16,a3) 				#XƂĂ
draw_block_mode_check: 				#d3(Y1) , d2(Y2)
	mov 	1,d0 					#PFPy[WɎ܂Ă
	mov 	d0,(draw_block_mode)
	cmp 	d2,d3
	beq 	draw_block_vramfix
	mov 	2,d0 					#QFQȏł
	mov 	d0,(draw_block_mode)
	sub 	d3,d2
	mov 	d2,(22,a3) 				#y[W
draw_block_vramfix:
	mov 	(0,a1),d0
	mov 	(0,a3),a0
	add 	d0,a0
	mov 	(8,a3),d2
	add 	-1,d2
draw_block_vramfix_2:
	cmp 	0,d2
	beq 	draw_block_vramfix_3
	add 	VRAM_LINE_MAX,a0
	add 	-1,d2
	jmp 	draw_block_vramfix_2
draw_block_vramfix_3:
	mov 	a0,(18,a3)

	mov 	(draw_block_mode),d0
	cmp 	1,d0
	beq 	draw_block_mode1
	cmp 	2,d0
	beq 	draw_block_mode2
	jmp 	draw_block_mode2
draw_block_mode1: 							#Py[W
	mov 	(18,a3),a0
	mov 	(16,a3),d3							#d3:JE^
draw_block_model1_1:
	mov 	draw_block_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	movbu 	(0,a0),d0
	and 	d0,d2

	mov 	draw_block_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d0 							#d2-y2 save
	mov 	d0,d1
	movbu 	(0,a0),d0
	and 	d0,d1
	or 		d1,d2
	mov 	d2,a1 								#ۑ
	
	movb 	(0,a0),d0
	mov 	0xff,d1
	or 		d1,d0
	mov 	draw_block_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	not 	d2
	and 	d2,d0

	mov 	draw_block_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	not 	d2
	and 	d2,d0
	
	mov 	a1,d1
	or 		d1,d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_block_model1_2:
	add 	1,a0
	add 	-1,d3
	bne 	draw_block_model1_1
	add 	24,a3
	rts

draw_block_mode2:
	mov 	(18,a3),a0
	mov 	(16,a3),d3							#d3:JE^
draw_block_model2_1:
	mov 	draw_block_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 save
	movbu 	(0,a0),d0
	and 	d0,d2
	mov 	d2,a1 								#ۑ
	
	movb 	(0,a0),d0
	mov 	0xff,d1
	or 		d1,d0
	mov 	draw_block_y1_save_table,a2
	mov 	(10,a3),d1
	movbu 	(d1,a2),d2 							#d2-y1 clear
	not 	d2
	and 	d2,d0
	
	mov 	a1,d1
	or 		d1,d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_block_model2_2:
	add 	1,a0
	add 	-1,d3
	bne 	draw_block_model2_1

draw_block_middle:
	mov 	(22,a3),d3
draw_block_middle2:
	add 	-1,d3
	beq 	draw_block_mode2_3

	mov 	(18,a3),a0
	add 	VRAM_LINE_MAX,a0
	mov 	a0,(18,a3)

	mov 	(16,a3),d2
draw_block_middle3:
	movb 	(0,a0),d0
	not 	d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_block_middle4:
	add 	1,a0
	add 	-1,d2
	bne 	draw_block_middle3
draw_block_middle5:
	jmp 	draw_block_middle2

draw_block_mode2_3:
	mov 	(18,a3),a0
	add 	VRAM_LINE_MAX,a0
	mov 	(16,a3),d3							#d3:JE^
draw_block_model2_4:
	mov 	draw_block_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d2 							#d2-y2 save
	movbu 	(0,a0),d0
	and 	d0,d2
	mov 	d2,a1 								#ۑ
	
	movb 	(0,a0),d0
	mov 	0xff,d1
	or 		d1,d0
	mov 	draw_block_y2_save_table,a2
	mov 	(14,a3),d1
	movbu 	(d1,a2),d2 							#d2-y2 clear
	not 	d2
	and 	d2,d0
	
	mov 	a1,d1
	or 		d1,d0
	extxbu 	d0
	movb 	d0,(0,a0)
draw_block_model2_5:
	add 	1,a0
	add 	-1,d3
	bne 	draw_block_model2_4
	add 	24,a3
	rts

.align 2
draw_block_mode: 	.short 0
draw_block_y1_save_table:
	.byte 	0b00000000,0b00000001,0b00000011,0b00000111,0b00001111,0b00011111,0b00111111,0b01111111
draw_block_y2_save_table:
	.byte 	0b11111110,0b11111100,0b11111000,0b11110000,0b11100000,0b11000000,0b10000000,0b00000000

















#==================
# Get DAYSEED ij
#==================
#jvZ̎擾B
#time_data擾ςɌB
#ij...time_data,dayseed̈̔Cӓ͂ɑΉ
#
#ij
#܂AN߂B́u2000N1231()vƂB
#āAtime_data猻ݔN擾AƊƂ̑Βl(P:)ZoB
#̑Βluday_seedvB
#j߂̂Aseed7ŊƂ悢B
#̗](0-6)̕j(ł͓j)YƂɂȂB
#
#EEEseedɂ͗jvZȊOɂAǂg肻B
#RTCԈȊOday_seedgetatimẻߒŎ擾łB

#íj
#a0:time_data (14bytes)
#a2:day_seed

getdayseed:
	sub 	d0,d0
	mov 	d0,mdr
	movbu 	(2,a0),d0
#	movbu 	(time_data+2),d0 		#20X
	jsr 	d0x10_with_d1
	movbu 	(3,a0),d2
#	movbu 	(time_data+3),d2 		#20X
	add 	d2,d0 					#bcdʏ̐ɒ
	mov 	d0,d3
	sub 	1,d3 					#d3:N2-1 (20001231j
	
									#܂AuNvɂĒׂ
	mov 	4,d1 					#N24Ŋ
	divu 	d1,d0 					#d0/d1 -> d0: mdr:]
	mov 	mdr,d2
	cmp 	0,d2 					#]0H
	beq 	getdayseed_leap 		#]肪[Ȃ獡N͉[Nł(2004...2008...2012...)
getdayseed_unleap:
	mov 	365,d1
	mulu 	d1,d3
	add 	d0,d3 					#365*(N2-1)+ ->d3:N̑A܂ł̑Βl
	mov 	un_leapyear_table,a1
	jmp 	getdayseed2

getdayseed_leap:
	sub 	1,d0 					#-1iwNx[NȂ̂j
	mov 	365,d1
	mulu 	d1,d3
	add 	d0,d3 					#365*(N2-1)+(-1) ->d3:N̑A܂ł̑Βl
	mov 	leapyear_table,a1

getdayseed2:
	movbu 	(4,a0),d0
#	movbu 	(time_data+4),d0 		#
	jsr 	d0x10_with_d1
	movbu 	(5,a0),d2
#	movbu 	(time_data+5),d2 		#
	add 	d2,d0 					#bcd->bin  d0:
	sub 	1,d0
	add 	d0,d0 					#x2ie[ũAhXvZj
	
	mov 	(d0,a1),d1 				#e[u炻d0-1܂ł̍v擾
	add 	d1,d3 					#d3:挎ŏI܂ł̑Βl
	
getdayseed3:
	movbu 	(6,a0),d0
#	movbu 	(time_data+6),d0 		#
	jsr 	d0x10_with_d1
	movbu 	(7,a0),d2
#	movbu 	(time_data+7),d2 		#
	add 	d2,d0 					#d0:
	
	add 	d0,d3 					#d3:SȑΒl
	mov 	d3,(0,a2)
#	mov 	d3,(day_seed) 			#Βlۊ

	rts

.align 2
	.lcomm day_seed			,2
leapyear_table:
	.short 0x0000,0x001f,0x003c,0x005b,0x0079,0x0098,0x00b6,0x00d5,0x00f4,0x0112,0x0131,0x014f,0x016e # [N :ʍve[u
un_leapyear_table:
	.short 0x0000,0x001f,0x003b,0x005a,0x0078,0x0097,0x00b5,0x00d4,0x00f3,0x0111,0x0130,0x014e,0x016d #[N:ʍve[u

#leapyear_table:
#	.short 0x0000,0x001f,0x003c,0x005b,0x0079,0x0098,0x00b6,0x00d5,0x00f4,0x0112,0x0131,0x014f,0x016f # [N :ʍve[u
#un_leapyear_table:
#	.short 0x0000,0x001f,0x003b,0x005a,0x0078,0x0097,0x00b5,0x00d4,0x00f3,0x0111,0x0130,0x014e,0x016e #[N:ʍve[u

#==================
# 	Get DAY
#==================
#day_seedāAday_dataɗj𓾂B
#íj
#a0:Ώday_seed
#a1:ۊǐday_data
#(day_data)
#:0  :1  :2  :3  :4  :5  y:6

getday:
	jsr 	reset_mdr_with_d0
	mov 	(a0),d0
	mov 	7,d1 					#ΐ؋yBj͍v7
	divu 	d1,d0
	mov 	mdr,d1 					#]擾B~̂͗]B
	mov 	d1,(a1)
	rts 							#񂾂

.align 2
	.lcomm day_data			,2

#==================
# 	Get AMPM (j
#==================
#12Ԑ(AM/PM)̃f[^𓾂B
#mode_ampm̒lɂāA3ނ12ԐɑΉB
#mode_ampm=1:24Ԑ0AM12:00A12PM12:00Ƃ^Cv12Ԑ(TYPE-1)
#mode_ampm=2:24Ԑ0PM12:00A12AM12:00Ƃ^Cv12Ԑ(TYPE-2)
#mode_ampm=3:24Ԑ0AM 0:00A12PM 0:00Ƃ^Cv12Ԑ(TYPE-3)
#mode_ampm=4:24Ԑ0AM 0:00A12PM12:00Ƃ^Cv12Ԑ(TYPE-4) *^
#܂Amode_ampm0(܂24Ԑ[h)̏ꍇ͑RTSB
#íj
#a0:ɂtime_data̕ۊǏꏊi24Ԑł邱Ɓj
#a1:o͂ampmf[^̕ۊǐ					: 0=am , 1=pm
#a2:o͂ampm␳ςtime_data̕ۊǐ
#d3:mode_ampm (0~4)

getampm:
#	mov 	(mode_ampm),d3
	cmp 	0,d3 					#AMPMIt(0)
	beq 	getampm_end 			#ȂΏIB
getampm2: 							#(BCD)ʏ툵鐔ɕϊ
	movbu 	(8,a0),d0 				#
	jsr 	d0x10_with_d1
	movbu 	(9,a0),d1
	add 	d0,d1 					#d1:ݎ(bin)
getampm3:
	cmp 	4,d3
	beq 	getampm_type4_p1 		#MODETYPE-4 ?

	cmp 	2,d3 					#MODETYPE-2H
	bne 	getampm4
getampm_type2_p1:
	cmp 	0,d1 					#"ߌ"H
	beq 	getampm_type2_p2
	cmp 	12,d1 					#"ߑO"H
	beq 	getampm_type2_p3
	jmp 	getampm4
getampm_type2_p2:
	mov 	1,d0
	mov 	d0,(a1) 				#"PM"
	jmp 	getampm_type2_p4
getampm_type2_p3:
	sub 	d0,d0
	mov 	d0,(a1) 				#"AM"
getampm_type2_p4:
	mov 	0x0201,d0 				#0x0102ł"12"ł͂ȂA"21"ɂȂĂ܂B
	mov 	d0,(8,a2) 				#F12
	jmp 	getampm_before_end

getampm_type4_p1:
	cmp 	0,d1 					#"ߑO"H
	beq 	getampm_type4_p2
	cmp 	12,d1 					#"ߌ"H
	beq 	getampm_type4_p3
	jmp 	getampm4
getampm_type4_p2:
	sub 	d0,d0
	mov 	d0,(a1) 				#"AM"
	sub 	d0,d0
	jmp 	getampm_type4_p4
getampm_type4_p3:
	mov 	1,d0
	mov 	d0,(a1) 				#"PM"
	mov 	0x0201,d0 				#0x0102ł"12"ł͂ȂA"21"ɂȂĂ܂B
getampm_type4_p4:
	mov 	d0,(8,a2) 				#F12
	jmp 	getampm_before_end


getampm4:
	cmp 	12,d1
	bcc 	getampm_pm 				#12ȏPM
getampm_am:
	sub 	d0,d0
	mov 	d0,(a1) 				#"AM"
	jmp 	getampm5
getampm_pm:
	add 	-12,d1 					#d1-12
	mov 	1,d0
	mov 	d0,(a1) 				#"PM"
getampm5:
	cmp 	3,d3 					#MODETYPE-3H
	beq 	getampm6
getampm_type1:
	cmp 	0,d1
	beq 	getampm_type2_p4 		#TYPE2̈ꕔ̏ƋʁB(0,12 -> 12)
getampm6:
	cmp 	10,d1
	bcc 	getampm6_h1 			#bcdɍĕϊ֌WŁA10ȏォŕ򂳂(divu)
getampm6_h0:
	sub 	d0,d0
	movb 	d0,(8,a2) 				#:0
	jmp 	getampm7
getampm6_h1:
	mov 	1,d0
	movb 	d0,(8,a2) 				#:1
	add 	-10,d1
getampm7:
	movb 	d1,(9,a2) 				#:d1
getampm_before_end:
	mov 	(a0),d0 				#͊time_dataRs[
	mov 	d0,(a2)
	mov 	(2,a0),d0
	mov 	d0,(2,a2)
	mov 	(4,a0),d0
	mov 	d0,(4,a2)
	mov 	(6,a0),d0
	mov 	d0,(6,a2)
	mov 	(10,a0),d0
	mov 	d0,(10,a2)
	mov 	(12,a0),d0
	mov 	d0,(12,a2)
getampm_end:
	rts

.align 2
	.lcomm time_ampm			,2
	.lcomm time_data_ampm 		,14


#==================
#	YMD2Vram40x8 ()
#==================
#wVRAMɍŏ̓t](4x8)
# _no_year tƔN\ȂB
#()
#a0:]VRAM
#a2:o͂ time_data`f[^
#d3:nCtXbV (0: "-" ) (1: "/" )

ymd2vram40x8_no_year:
	cmp 	1,d3
	beq 	ymd2vram40x8_m01_slash
	jmp 	ymd2vram40x8_m01
ymd2vram40x8:
	cmp 	1,d3 					#"/"[hH
	beq 	ymd2vram40x8_slash
	movbu 	(0,a2),d1 				#Nꌅ
	jsr 	num2vram4x8 			#a0+4
	movbu 	(1,a2),d1 				#N񌅖
	jsr 	num2vram4x8 			#a0+4(8)
	movbu 	(2,a2),d1 				#Nꌅ
	jsr 	num2vram4x8 			#a0+4(12)
	movbu 	(3,a2),d1 				#N񌅖
	jsr 	num2vram4x8 			#a0+4(16)
	mov 	yhi4x8,a1
	jsr 	symbol2vram4x8 			#20XX-̃nCt] a0+4(20)
ymd2vram40x8_m01:
	movbu 	(4,a2),d1 				#ꌅ
	cmp 	0,d1 					# 0H
	beq 	ymd2vram40x8_m01_s 		#Ȃ΃XLbv
	jsr 	num2vram4x8 			#a0+4(24)
	jmp 	ymd2vram40x8_m02 		#XLbv
ymd2vram40x8_m01_s:
	mov 	a0,a1
	mov 	4,d1
	jsr 	clear_vram_p 			#4x8NA
	add 	4,a0 					#a0+4(24)
ymd2vram40x8_m02:
	movbu 	(5,a2),d1 				#񌅖
	jsr 	num2vram4x8 			#a0+4(28)
	mov 	yhi4x8,a1
	jsr 	symbol2vram4x8 			#20XX-XX-̃nCt]a0+4(32)
ymd2vram40x8_d01:
	movbu 	(6,a2),d1 				#ꌅ
	cmp 	0,d1 					# 0?
	beq 	ymd2vram40x8_d01_s 		#Ȃ΃XLbv
	jsr 	num2vram4x8 			#a0+4(36)
	jmp 	ymd2vram40x8_d02 		#XLbv
ymd2vram40x8_d01_s:
	mov 	a0,a1
	mov 	4,d1
	jsr 	clear_vram_p 			#4x8NA
	add 	4,a0 					#a0+4(36)
ymd2vram40x8_d02:
	movbu 	(7,a2),d1 				#񌅖
	jsr 	num2vram4x8 			#a0+4(40)
ymd2vram40x8_end:
	rts


ymd2vram40x8_slash:
	movbu 	(0,a2),d1 					#Nꌅ
	jsr 	num2vram4x8 				#a0+4
	movbu 	(1,a2),d1 					#N񌅖
	jsr 	num2vram4x8 				#a0+4(8)
	movbu 	(2,a2),d1 					#Nꌅ
	jsr 	num2vram4x8 				#a0+4(12)
	movbu 	(3,a2),d1 					#N񌅖
	jsr 	num2vram4x8 				#a0+4(16)
	mov 	han_e_font+45,a1
	jsr 	symbol2vram4x8 				#20XX/̃XbV] a0+4(20)
ymd2vram40x8_m01_slash:
	movbu 	(4,a2),d1 					#ꌅ
	cmp 	0,d1 						# 0H
	beq 	ymd2vram40x8_m01_s_slash 	#Ȃ΃XLbv
	jsr 	num2vram4x8 				#a0+4(24)
	jmp 	ymd2vram40x8_m02_slash 		#XLbv
ymd2vram40x8_m01_s_slash:
	mov 	a0,a1
	mov 	4,d1
	jsr 	clear_vram_p 				#4x8NA
	add 	4,a0 						#a0+4(24)
ymd2vram40x8_m02_slash:
	movbu 	(5,a2),d1 					#񌅖
	jsr 	num2vram4x8 				#a0+4(28)
	mov 	han_e_font+45,a1
	jsr 	symbol2vram4x8 				#20XX/XX/̃nCt]a0+4(32)
ymd2vram40x8_d01_slash:
	movbu 	(6,a2),d1 					#ꌅ
	cmp 	0,d1 						# 0?
	beq 	ymd2vram40x8_d01_s_slash 	#Ȃ΃XLbv
	jsr 	num2vram4x8 				#a0+4(36)
	jmp 	ymd2vram40x8_d02_slash 		#XLbv
ymd2vram40x8_d01_s_slash:
	mov 	a0,a1
	mov 	4,d1
	jsr 	clear_vram_p 				#4x8NA
	add 	4,a0 						#a0+4(36)
ymd2vram40x8_d02_slash:
	movbu 	(7,a2),d1 					#񌅖
	jsr 	num2vram4x8 				#a0+4(40)
ymd2vram40x8_end_slash:
	rts


#==================
#	DAY2Vram12x8
#==================
#VRAMɍŏ̗j(12x8)]
#()
#a0:]VRAM
#a2:Ώday_data

day2vram12x8:
	mov 	(a2),d0 				#j
	add 	d0,d0
	add 	d0,d0 					#x4
	mov 	day_name,a1
	add 	d0,a1 					#YjAhX擪
	jsr 	str2vram 				#o
	rts

.align 2
day_name:
	.asciz "Sun"
	.asciz "Mon"
	.asciz "Tue"
	.asciz "Wed"
	.asciz "Thu"
	.asciz "Fri"
	.asciz "Sat"

#==================
#	HM2Vram40x16 ()
#==================
#wVRAMɔrI傫(8x16)]
#()
#a0:]VRAM
#a2:Cӂtime_data

hm2vram40x16:
	movbu 	(8,a2),d1 				#ꌅ
	cmp 	0,d1 					# 0?
	beq 	hm2vram40x16_s 			#Ȃ΃XLbv
	jsr 	num2vram8x16 			#a0+8
	jmp 	hm2vram40x16_h02 		#XLbv
hm2vram40x16_s:
	mov 	a0,a1
	mov 	8,d1
	jsr 	clear_vram_p 			#8x8NA
	mov 	a0,a1
	add 	102,a1
	mov 	8,d1
	jsr 	clear_vram_p 			#8x8NA
	add 	8,a0 					#VRAM␳a0+8(16)
hm2vram40x16_h02:
	movbu 	(9,a2),d1 				#ꌅ
	jsr 	num2vram8x16 			#a0+8(16)
	
	mov 	yco8x16,a1
	jsr 	symbol2vram8x16 		# : ]a0+8(24)
hm2vram40x16_m:
	movbu 	(10,a2),d1 				#ꌅ
	jsr 	num2vram8x16 			#a0+8(32)
	movbu 	(11,a2),d1 				#ꌅ
	jsr 	num2vram8x16 			#a0+8(40)
hm2vram40x16_end:
	rts

#==================
#	Sec2Vram16x8
#==================
#wVRAMɒ炢(8x8)̕b]
#()
#a0:]VRAM
#a2:Cӂtime_data

sec2vram16x8:
	movbu 	(12,a2),d1 				#bꌅ
	jsr 	num2vram8x8 			#a0+8
	movbu 	(13,a2),d1 				#bꌅ
	jsr 	num2vram8x8 			#a0+8(16)
	rts

#==================
#	AMPM2Vram8x8 (j
#==================
#time_ampmɉ4x8tHgŁuAMvuPMv]B
#mode_ampm0̏ꍇɂ͑rtsB
#ampm֘Ãf[^炩ߎ擾ĂȂƎgȂB
#íj
#a0:]VRAM
#a2:Ώampmf[^
#d3:mode_ampm

ampm2vram8x8:
	mov 	d3,d0
	cmp 	0,d0
	beq 	ampm2vram8x8_end2
	
ampm2vram8x8_trans:
	mov 	(a2),d0 				#d0 : O(AM) P(PM)
	mov 	d0,d1
	add 	d0,d0
	add 	d1,d0 					#d0x3 (AhXvZ)
	
	mov 	ampm_name,a1
	add 	d0,a1 					#␳
	
	jsr 	str2vram 				#]

ampm2vram8x8_end:
	rts
ampm2vram8x8_end2:
	sub 	d0,d0
	movb 	d0,(0,a0)
	movb 	d0,(1,a0)
	movb 	d0,(2,a0)
	movb 	d0,(3,a0)
	movb 	d0,(4,a0)
	movb 	d0,(5,a0)
	movb 	d0,(6,a0)
	movb 	d0,(7,a0) 				#NA
	add 	8,a0
	rts

.align 2
ampm_name:
	.asciz "Am"
	.asciz "Pm"

#==================
#	Num2Vram4x8
#==================
#ꌅ̐(0-9)ꕶƂVRAMɓ](4x8)
#()
#d1:o͐iꌅj
#a0:]VRAM

num2vram4x8_extra_small:
	mov 	d1,d0
	add 	d0,d0
	add 	d1,d0 					#d1x3 ->d0
	mov 	ynum4x8_small,a1 		#ɏtHg̈ʒu
	jmp 	num2vram4x8_trans2
num2vram4x8:
	mov 	d1,d0
	add 	d0,d0
	add 	d1,d0 					#d1x3 ->d0
num2vram4x8_trans:
	mov 	han_e_font+48,a1 		#4x8̐tHg -> a1
num2vram4x8_trans2:
	add 	d0,a1 					#f[^̃AhX␳
	movbu 	(0,a1),d0 				#1bit
	movb 	d0,(0,a0)
	movbu 	(1,a1),d0 				#2bit
	movb 	d0,(1,a0)
	movbu 	(2,a1),d0 				#3bit
	movb 	d0,(2,a0)
	sub 	d0,d0
	movb 	d0,(3,a0) 				#4bit :0x00
num2vram4x8_end:
	add 	4,a0 					#␳
	rts

#==================
#	Num2Vram8x8
#==================
#ꌅ̐(0-9)ꕶƂVRAMɓ](8x8)
#()
#d1:o͐iꌅj
#a0:]VRAM

num2vram8x8:
	mov 	d1,d0
	add 	d0,d0 					#x2
	add 	d0,d0 					#x4
	add 	d0,d0 					#x8
	sub 	d1,d0 					#x7ɏC -> d0
num2vram8x8_select:
	mov 	ynum8x8,a1 				#8x8tHg -> a1
	add 	d0,a1 					#AhX␳
	
	mov 	2,d2 					#[vJE^
num2vram8x8_trans01:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0)
	movbu 	(1,a1),d0
	movb 	d0,(1,a0)
	movbu 	(2,a1),d0
	movb 	d0,(2,a0)
	
	add 	3,a0
	add 	3,a1
	add 	-1,d2
	bne 	num2vram8x8_trans01
num2vram8x8_trans02:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0) 				#7bit
	sub 	d0,d0
	movb 	d0,(1,a0) 				#8bit(0x00)
	
	add 	2,a0
num2vram8x8_end:
	rts

#==================
#	Num2Vram8x16
#==================
#ꌅ̐(0-9)ꕶƂVRAMɓ](8x16)
#()
#d1:o͐iꌅj
#a0:]VRAM

num2vram8x16:
	mov 	d1,d0
	add 	d0,d0
	add 	d0,d0
	add 	d0,d0
	sub 	d1,d0 					#x7
	add 	d0,d0 					#x14 -> d0
num2vram8x16_select:
	mov 	ynum8x16,a1 			#8x16tHg -> a1
	add 	d0,a1 					#AhX␳
	mov 	3,d2 					#[vJE^
num2vram8x16_trans01:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0) 				#
	movbu 	(7,a1),d0
	movb 	d0,(102,a0) 			#
	
	movbu 	(1,a1),d0
	movb 	d0,(1,a0) 				#
	movbu 	(8,a1),d0
	movb 	d0,(103,a0) 			#
	
	add 	2,a0
	add 	2,a1
	add 	-1,d2
	bne 	num2vram8x16_trans01
num2vram8x16_trans02:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0)
	movbu 	(7,a1),d0
	movb 	d0,(102,a0) 			#7bit
	
	sub 	d0,d0
	movb 	d0,(1,a0)
	movb 	d0,(103,a0) 			#8bit(0x00)
	
	add 	2,a0
num2vram8x16_end:
	rts

#==================
#	Symbol2Vram8x16
#==================
#wVRAM8x16̃V{iLj]
#íj
#a0:]VRAM
#a1:]ΏۋLf[^擪AhX(8x16̂)

symbol2vram8x16:
	mov 	3,d2 					#[vJE^
symbol2vram8x16_trans01:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0) 				#
	movbu 	(7,a1),d0
	movb 	d0,(102,a0) 			#
	
	movbu 	(1,a1),d0
	movb 	d0,(1,a0) 				#
	movbu 	(8,a1),d0
	movb 	d0,(103,a0) 			#
	
	add 	2,a0
	add 	2,a1
	add 	-1,d2
	bne 	symbol2vram8x16_trans01
symbol2vram8x16_trans02:
	movbu 	(0,a1),d0
	movb 	d0,(0,a0) 				#7bit - 
	movbu 	(7,a1),d0
	movb 	d0,(102,a0) 			#7bit - 
	
	sub 	d0,d0
	movb 	d0,(1,a0) 				#8bit - 
	movb 	d0,(103,a0) 			#8bit - 
symbol2vram8x16_end:
	add 	2,a0
	rts




