##=====================##
## Common Menu Section ##
##=====================##

menu_section:
	jsr 	restore_vram
############################################# MENU EXEC
menu_exec_section:
mes:
	mov 	(flag_chi),d0
	cmp 	1,d0
	beq 	mes_chi
mes_par: 							################ PARENT MENU
mes_par_up: 						##UP : MENU-OFF
	mov 	(flag_up),d0
	cmp 	1,d0
	bne 	mes_par_dw
	
	sub 	d0,d0
	mov 	d0,(flag_menu)
	jsr 	restart_timer
#	jmp 	mes_par_end 			#ꍇDISPZNVpX
	jmp 	mds_end
mes_par_dw: 						##DW : OPEN_CHILDMENU
	mov 	(flag_dw),d0
	cmp 	1,d0
	bne 	mes_par_le
mes_par_dw2:
	mov 	(par_menu),d0
	mov 	8,d1
	mulu 	d1,d0 					#par_menu*8 -> d0
	mov 	menu_list,a1
	add 	2,a1
	add 	d0,a1
	add 	4,a1
	mov 	(a1),a2
	mov 	a2,(pt_chi)
	
	mov 	1,d0
	mov 	d0,(flag_chi)
	jmp 	mes_par_end
mes_par_le: 						##LE : PAR_MENU -- LOOP
	mov 	(flag_le),d0
	cmp 	1,d0
	bne 	mes_par_ri

	mov 	par_menu,a0
	mov 	menu_list,a1
	jsr 	loop_dw
	jmp 	mes_par_end
mes_par_ri: 						##RI : PAR_MENU ++ LOOP
	mov 	(flag_ri),d0
	cmp 	1,d0
	bne 	mes_par_en

	mov 	par_menu,a0
	mov 	menu_list,a1
	jsr 	loop_up
	jmp 	mes_par_end
mes_par_en:
	mov 	(flag_en),d0
	cmp 	1,d0
	bne 	mes_par_me
	jmp 	mes_par_dw2
mes_par_me:
	mov 	(flag_me),d0
	cmp 	1,d0
	bne 	mes_par_fi
	
	sub 	d0,d0
	mov 	d0,(flag_menu)
	jsr 	restart_timer
#	jmp 	mes_par_end
	jmp 	mds_end
mes_par_fi:
	mov 	(flag_fi),d0
	cmp 	1,d0
	bne 	mes_par_end

	jsr 	clone_vram
	mov 	1,d0
	mov 	d0,(flag_laun)
	mov 	d0,(flag_pass)
	sub 	d0,d0
	mov 	d0,(flag_menu)
	
	jmp 	mes_par_end
mes_par_end:
	jmp 	mes_end


mes_chi: 							################ CHILD MENU
mes_chi_up: 						##UP : CHI_MENU=0 ?
									##Y:CLOSE CHILD MENU /N:DEC CHI_MENU
	mov 	(flag_up),d0
	cmp 	1,d0
	bne 	mes_chi_dw
	
	mov 	(chi_menu),d0
	cmp 	0,d0
	bne 	mes_chi_up_dec
mes_chi_up_close:
	sub 	d0,d0
	mov 	d0,(flag_chi)
	jmp 	mes_chi_end
mes_chi_up_dec:
	add 	-1,d0
	mov 	d0,(chi_menu)
	jmp 	mes_chi_end
mes_chi_dw: 						##DW : CHI_MENU ++ LOOP
	mov 	(flag_dw),d0
	cmp 	1,d0
	bne 	mes_chi_le
	
	mov 	chi_menu,a0
	mov 	(pt_chi),a1
	add 	4,a1
	jsr 	loop_up
	jmp 	mes_chi_end
mes_chi_le: 						##LE : UP MENU
	mov 	(flag_le),d0
	cmp 	1,d0
	bne 	mes_chi_ri
	
	mov 	(pt_chi),a1
	mov 	(a1),a2
	mov 	a2,(pt_chi)
	sub 	d0,d0
	mov 	d0,(chi_menu)
	
	cmp 	a1,a2
	bne 	mes_chi_end 			## pt_chi == Return Address
	
	mov 	(par_menu),d0
	cmp 	0,d0
	beq 	mes_chi_le2
	add 	-1,d0
	mov 	d0,(par_menu)
	jmp 	mes_par_dw2
mes_chi_le2:
	mov 	menu_list,a0
	mov 	(a0),d0
	add 	-1,d0
	mov 	d0,(par_menu)
	jmp 	mes_par_dw2
mes_chi_le_end:
	jmp 	mes_chi_end
mes_chi_ri: 						##RI : DIVE or EXEC
	mov 	(flag_ri),d0
	cmp 	1,d0
	bne 	mes_chi_en
mes_chi_ri_common:
	mov 	(pt_chi),a1
	add 	6,a1
	mov 	(chi_menu),d0
#	mov 	8,d1 					# 										*
	mov 	12,d1 					# 										*
	mulu 	d1,d0
	add 	d0,a1

	mov 	(a1),a2
	movbu 	(0,a2),d0
	cmp 	'|',d0 					#|:EXEC/>:DIVE
	beq 	mes_chi_ri_exec
mes_chi_ri_dive:
	add 	4,a1
	mov 	(a1),a2
	mov 	a2,(pt_chi)
	sub 	d0,d0
	mov 	d0,(chi_menu)
	jmp 	mes_chi_end
mes_chi_ri_exec:
	add 	4,a1
	mov 	(a1),a2
	jmp 	(a2) 					#GO!
mes_chi_en:
	mov 	(flag_en),d0
	cmp 	1,d0
	bne 	mes_chi_me

	jmp 	mes_chi_ri_common
mes_chi_me:
	mov 	(flag_me),d0
	cmp 	1,d0
	bne 	mes_chi_fi
	
	sub 	d0,d0
	mov 	d0,(flag_menu)
	jsr 	restart_timer
#	jmp 	mes_chi_end
	jmp 	mds_end
mes_chi_fi:
	mov 	(flag_fi),d0
	cmp 	1,d0
	bne 	mes_par_end

	jsr 	clone_vram
	mov 	1,d0
	mov 	d0,(flag_laun)
	mov 	d0,(flag_pass)
	sub 	d0,d0
	mov 	d0,(flag_menu)
#	jmp 	mes_chi_end
	jmp 	mds_end
mes_chi_end:
	jmp 	mes_end
mes_end:
	jmp 	menu_disp_section

############################################# MENU DISP
	.equ 	MENU_RANGE 	, 102
	.equ 	CHI_RANGE 	, 44+6 		#*
menu_disp_section:
mds:
mds_par: 							##DISP PARENT MENU
mds_par_clear:
	mov 	vram+4,a1
	mov 	MENU_RANGE,d1
	jsr 	clear_vram_p
	
	mov 	vram+4+102,a0
	mov 	MENU_RANGE,d2
	mov 	0xfe,d1
mds_par_clear2:
	movb 	(0,a0),d0
	and 	d1,d0
	movb 	d0,(0,a0)
	add 	1,a0
	add 	-1,d2
	bne 	mds_par_clear2
mds_par_char:
	add 	-8,a3
	mov 	(menu_list),d3 		#d3:COUNTER(MAX)
	cmp 	0,d3
	beq 	mds_par_char_end
	mov 	(par_menu),d0
	mov 	d0,(a3)

	mov 	vram+4+2,a0
	mov 	menu_list+2,a2
mds_par_char2:
	mov 	(a3),d0
	cmp 	0,d0
	beq 	mds_par_char_rev
	
	mov 	(a2),a1
	mov 	a2,(4,a3)
	jsr 	str2vram_count
	mov 	(4,a3),a2

	add 	4,a0
	add 	8,a2
	mov 	(a3),d0
	add 	-1,d0
	mov 	d0,(a3)
	add 	-1,d3
	bne 	mds_par_char2
	jmp 	mds_par_char_end
mds_par_char_rev:
	mov 	(a2),a1
	mov 	a2,(4,a3)
	jsr 	str2vram_count 			#d2
	mov 	(4,a3),a2
	mov 	4,d0
	mulu 	d0,d2
	add 	2,d2
	sub 	d2,a0
#	add 	2,d2
	mov 	d2,d1
	add 	1,d1
	mov 	d3,(2,a3)
	jsr 	reverse_area
	mov 	(2,a3),d3

	add 	3,a0
	add 	8,a2
	mov 	(a3),d0
	add 	-1,d0
	mov 	d0,(a3)
	add 	-1,d3
	bne 	mds_par_char2
	jmp 	mds_par_char_end
mds_par_char_end:
	add 	8,a3

mds_par_shift:
	mov 	MENU_RANGE,d3
	mov 	vram+4,a0
mds_par_shift2:
	mov 	(a0),d0
	ror 	d0
	mov 	d0,(a0)
	add 	2,a0
	add 	-2,d3
	bne 	mds_par_shift2

mds_par_line:
	mov 	0x7f,d0
	mov 	vram+4,a0
	movb 	d0,(0,a0)
	movb 	d0,(MENU_RANGE-1,a0)
	mov 	0x8080,d0
	mov 	MENU_RANGE,d2
	mov 	vram+4,a0
mds_par_line2:
	mov 	(a0),d1
	or	 	d0,d1
	mov 	d1,(a0)
	add 	2,a0
	add 	-2,d2
	bne 	mds_par_line2
mds_par_end:
	mov 	(flag_chi),d0
	cmp 	0,d0
	beq 	mds_end
mds_chi:							##DISP CHILD MENU
	add 	-10,a3
mds_chi_count: 						#Calc CHILD-MENU-POS.
	mov 	menu_list,a2
	add 	2,a2
	mov 	(par_menu),d3
	sub 	d2,d2
	cmp 	0,d3
	beq 	mds_chi_count_0end
	sub 	d0,d0
	mov 	d0,(chi_menu_zero_flag)
mds_chi_count2:
	mov 	(a2),a0
	jsr 	word_count
	add 	d1,d2
	add 	1,d2
	add 	8,a2
	add 	-1,d3
	bne 	mds_chi_count2
mds_chi_count3:
	mov 	4,d0
	mulu 	d0,d2 					# F(IRST POS)
	mov 	d2,d3
mds_chi_count4:
	add 	CHI_RANGE,d2 			# F + R(ANGE)
	cmp 	102,d2
	bgt 	mds_chi_count_over 		# F + R > 102(LCD-MAX) ? 
	mov 	d3,d2
	sub 	d0,d0
	mov 	d0,(chi_menu_over_flag)
 	jmp 	mds_chi_count_end
mds_chi_count_over:
	mov 	102,d2
	sub 	CHI_RANGE,d2
	mov 	1,d0
	mov 	d0,(chi_menu_over_flag)
	jmp 	mds_chi_count_end
mds_chi_count_0end:
	mov 	1,d0
	mov 	d0,(chi_menu_zero_flag)
mds_chi_count_end:
	mov 	d2,(a3) 				# (0,a3) : CHILD-MENU-POS (2bytes)
mds_chi_clear:
	mov 	vram+4+102,a1
	add 	d2,a1
	mov 	a1,(2,a3)
	
	mov 	(pt_chi),a0
	mov 	(4,a0),d3
mds_chi_clear2:
	mov 	CHI_RANGE,d1
	mov 	(chi_menu_zero_flag),d0
	cmp 	1,d0
	beq 	mds_chi_clear2_zero
	mov 	(chi_menu_over_flag),d0
	cmp 	1,d0
	beq 	mds_chi_clear2_over
	
	add 	2,d1
	mov 	(2,a3),d0
	add 	-1,d0
	mov 	d0,(2,a3)
	
	jmp 	mds_chi_clear2_2
mds_chi_clear2_zero:
	add 	1,d1
	jmp 	mds_chi_clear2_2
mds_chi_clear2_over:
	add 	1,d1
	mov 	(2,a3),d0
	add 	-1,d0
	mov 	d0,(2,a3)

mds_chi_clear2_2:
	mov 	d1,d2
	mov 	(2,a3),a1
	jsr 	clear_vram_p

	mov 	(2,a3),a1
	add 	102,a1
	mov 	a1,(2,a3)
	mov 	d2,d1
	add 	-1,d3
	bne 	mds_chi_clear2_2 			#*
mds_chi_clear3:
	mov 	d1,d3
mds_chi_clear3_2:
	mov 	(2,a3),a1
#	mov 	0xfc,d1
	mov 	0xf8,d1
mds_chi_clear4:
	movb 	(0,a1),d0
	and 	d1,d0
	movb 	d0,(0,a1)
	
	add 	1,a1
	add 	-1,d3
	bne 	mds_chi_clear4


mds_chi_symbol: 					# > or |
	mov 	(pt_chi),a2
	add 	4,a2
	mov 	(a2),d3
	add 	2,a2
	mov 	vram+4+102,a0
	mov 	(a3),d0
	add 	d0,a0
	add 	CHI_RANGE-4,a0
	mov 	a0,(2,a3)
mds_chi_symbol2:
	mov 	(2,a3),a0
	mov 	(a2),a1
	movbu 	(0,a1),d0
	cmp 	'>',d0
	beq 	mds_chi_symbol2_dive
mds_chi_symbol2_exec:
	mov 	exec_icon,a1
	jmp 	mds_chi_symbol3
mds_chi_symbol2_dive:
	mov 	next_icon,a1
mds_chi_symbol3:
	jsr 	symbol2vram4x8
	mov 	(2,a3),a0
	add 	102,a0
	mov 	a0,(2,a3)
#	add 	8,a2 									#*
	add 	12,a2 									#*
	add 	-1,d3
	bne 	mds_chi_symbol2


mds_chi_check:
	mov 	(pt_chi),a2
	add 	6,a2 									# &check
	mov 	(-2,a2),d3
	mov 	a2,(6,a3)
	cmp 	0,d3
	beq 	mds_chi_check_end
	mov 	vram+4+102+2,a0
	mov 	(a3),d0
	add 	d0,a0
	mov 	a0,(2,a3)
mds_chi_check2:
	mov 	(2,a3),a0
	mov 	(8,a2),a1
	mov 	(a1),d2 								#0 or 1
	cmp 	0,d2
	beq 	mds_chi_check3

	mov 	a2,(6,a3)

	mov 	check_icon,a2
	movb 	(0,a0),d1
	movb 	(0,a2),d0
	or 		d1,d0
	movb 	d0,(0,a0)

	movb 	(1,a0),d1
	movb 	(1,a2),d0
	or 		d1,d0
	movb 	d0,(1,a0)

	movb 	(2,a0),d1
	movb 	(2,a2),d0
	or 		d1,d0
	movb 	d0,(2,a0)

	movb 	(3,a0),d1
	movb 	(3,a2),d0
	or 		d1,d0
	movb 	d0,(3,a0)

	mov 	(6,a3),a2

mds_chi_check3:	
	mov 	(2,a3),a0
	add 	102,a0
	mov 	a0,(2,a3)
	mov 	(6,a3),a2
	add 	12,a2 									#*
	mov 	a2,(6,a3)
	add 	-1,d3
	bne 	mds_chi_check2
mds_chi_check_end:
	nop


mds_chi_char:
	mov 	(pt_chi),a2
	add 	6,a2
	mov 	(-2,a2),d3
	cmp 	0,d3
	beq 	mds_chi_char_end
	mov 	vram+4+102+2,a0
	mov 	(a3),d0
	add 	6,d0 									#*
	add 	d0,a0
	mov 	a0,(2,a3)
mds_chi_char2:
	mov 	(2,a3),a0
	mov 	(a2),a1
	add 	1,a1
	mov 	a2,(6,a3)
	jsr 	str2vram
	mov 	(6,a3),a2
	
	mov 	(2,a3),a0
	add 	102,a0
	mov 	a0,(2,a3)
	mov 	(6,a3),a2
#	add 	8,a2 									#*
	add 	12,a2 									#*
	mov 	a2,(6,a3)
	add 	-1,d3
	bne 	mds_chi_char2
mds_chi_char_end:
	nop
mds_chi_rev:
	mov 	(chi_menu),d1
	mov 	102,d0
	mulu 	d1,d0
	mov 	(a3),d2
	mov 	vram+4+102,a0
	add 	d2,a0
	add 	d0,a0
	
	mov 	CHI_RANGE,d1
	jsr 	reverse_area_d

mds_chi_line:
	mov 	(pt_chi),a2
	add 	4,a2
	mov 	(a2),d3
	cmp 	0,d3
	beq 	mds_chi_line_end
	mov 	vram+4+102,a0
	mov 	(a3),d0
	add 	d0,a0
	mov 	0xff,d1
mds_chi_line2:
	movb 	d1,(0,a0)
	movb 	d1,(CHI_RANGE-1,a0)
	
	add 	102,a0
	add 	-1,d3
	bne 	mds_chi_line2
mds_chi_line_end:
	mov 	0x03,d1
	movbu 	(0,a0),d0
	or 		d1,d0
	movb 	d0,(0,a0)
	movbu 	(CHI_RANGE-1,a0),d0
	or 		d1,d0
	movb 	d0,(CHI_RANGE-1,a0)
	mov 	0x0202,d1
	mov 	CHI_RANGE,d3
mds_chi_line_end2:
	mov 	(a0),d0
	or 		d1,d0
	mov 	d0,(a0)
	
	add 	2,a0
	add 	-2,d3
	bne 	mds_chi_line_end2
mds_chi_end:
	add 	10,a3
mds_end:
	jsr 	lcd_display
	jmp 	clear_section

###########################SUB ROUTINE

.align 2

exec_icon: 				.byte 0x00,0x38,0x00
next_icon: 				.byte 0x7c,0x38,0x10
check_icon: 			.byte 0x20,0x40,0x20,0x10

chi_menu_over_flag: 	.short 0 					#qj[E[ɐڂĂ
chi_menu_zero_flag: 	.short 0 					#qj[[ɐڂĂ

